with Ada.Text_IO,
     Ada.Containers.Vectors,
     Ada.Containers.Indefinite_Ordered_Maps,
     Minfr.Activity_Processor;

use Ada.Text_IO,
    Ada.Containers,
    Minfr.Activity_Processor;

package minfr.Debug is


   Procedure print (bool : boolean;str : string);
   Procedure print_Fichero (Fichero,str : string;sel : natural);
   Procedure Close_Fichero (Fichero : string);
   Procedure print_Pulse (bool : boolean;str : string);
   Procedure Pulse_key (bool : boolean);
   function  Get_keys (bool : boolean) return string;
   Procedure Loop_TA;
   Procedure Loop_TB;
   Procedure Star_TA;
   Procedure Star_TB;


   debug1 : boolean := false;
   debug2 : boolean := false;
   debug3 : boolean := false;
   debug4 : boolean := false;

   --task Task_debug is

   --   end Task_debug; -- especificacin de la tarea




private

    type Ficheros is record
         N_Fich : Integer range 1..100;
         Nombre : String(1..40);
         N_Nombre : Integer range 0..40;
         bool : boolean := false;
   end record;

   package Type_Vec_Fichero is new Ada.Containers.Indefinite_Ordered_Maps
     (Key_Type => string,
      Element_Type => Ficheros,
      "<" => "<");
   use  Type_Vec_Fichero;



   type Vec_Fich is array (1..100) of File_Type;



   protected type Protec_Debug is

      procedure Debug_Stop_TA;
      procedure Debug_Stop_TB;
      procedure Debug_Star_TA;
      procedure Debug_Star_TB;
      function  Debug_Read_TA return Boolean;
      function  Debug_Read_TB return Boolean;

      Procedure Protec_print_Fichero (Fichero,str : string;sel : natural);
      Procedure Protec_Close_Fichero (Fichero : string);

   private
      Bool_TA : Boolean := False;
      Bool_TB : Boolean := False;

      Fich : Vec_Fich;
      Map_Fichero : Type_Vec_Fichero.Map;
      N_Fich : Integer range 1..21 := 1;

   end Protec_Debug;

   Protec_Debug_Data : Protec_Debug;

end minfr.Debug;
