with minfr.Debug;
use minfr.Debug;

package body minfr.Transition is

   function Constr_Transition (Name : string) return Ptr_Transition is
   begin
       return Tmp : Ptr_Transition do
         Tmp := new Transition;
         Tmp.state := 0;
         Tmp.Name := to_unbounded_string(Name);
      end return;
   end Constr_Transition;

   ----------------------------------------------------------------
   function Evaluate_Transition (this : Transition) return boolean is
      result : boolean := false;
      cursor : Vector_Vector.Cursor;
      debug : Boolean := false;
   begin
      print(debug,"Transition--Evaluate_Transition--conditions.Length =" & Index_Vector'Image(Index_Vector(this.conditions.Length)));
      Pulse_key(debug);
      if this.conditions.Length > 0 then
         For_Loop :
         for I in Index_Vector range 0 .. Index_Vector(this.conditions.Length-1) loop
            result := this.Evaluate_Conditions(this.conditions.Element(I));
            print(debug,"Transition--Evaluate_Transition--this.Evaluate_Conditions(this.conditions(" & Index_Vector'Image(I) & "))" & boolean'Image(result));
            if result then
               exit  For_Loop;
            end if;
         end loop For_Loop;
      end if;

      print(debug,"Transition--Evaluate_Transition--return--" & boolean'Image(result));
      return result;

      exception
      when others =>
         print(true,"Transition--Evaluate_Transition--" & this.Get_Name &"--exception");
         delay 10.00;
         return true;
   end Evaluate_Transition;

   procedure Add_Conditions (this : in out Transition; vec : Vector_ptr_Condition.Vector) is
   begin
      --this.conditions := this.conditions & vec;
      print(debug,"Transition--Add_Conditions--conditions.Length =" & Index_Vector'Image(Index_Vector(this.conditions.Length)));
      this.conditions.Append(vec);
      print(debug,"Transition--Add_Conditions--conditions.Length =" & Index_Vector'Image(Index_Vector(this.conditions.Length)));
      --delay 10.0;
      --conditions.push_back(cond); ?????
   end Add_Conditions;

   procedure Add_Condition (this : in out Transition; Cond : Ptr_Condition) is
      Vec_Condi_State : Vector_ptr_Condition.Vector;
   begin
      Vec_Condi_State.Append(Ptr_Condition(Cond));
      this.Add_Conditions(Vec_Condi_State);
   end Add_Condition;

   procedure Set_State (this : in out Transition; id : State_Id) is
   begin
      print(debug,"Transition--Set_State--this.state =" & State_Id'Image(id));
      this.state := id;
   end Set_State;

   function Get_State (this : Transition) return State_Id is
   begin
      print(debug,"Transition--Get_State--return =" & State_Id'Image(this.state));
      return this.state;
   end Get_State;

   function Get_Name (this : Transition)return string is
   begin
      return to_string(this.name);
   end Get_Name;

   -------------------------private--------------------------------

   function Evaluate_Conditions (this : Transition ; vec : Vector_ptr_Condition.Vector) return boolean is
      result : boolean := true;
      debug : Boolean := false;
   begin
      print(debug,"Transition--Evaluate_Conditions--vec.Length ="& Index_Vector'Image(Index_Vector(vec.Length)));
      Pulse_key(debug);
      if vec.Length > 0 then
         For_Loop :
         for I in Index_Vector range 0 .. Index_Vector(vec.Length-1) loop
            result := vec.Element(I).Evaluate_Condition;
            print(debug,"Transition--Evaluate_Conditions--result := vec.Element("& Index_Vector'Image(I) & ").Evaluate_Condition =" & boolean'Image(result));
            Pulse_key(debug);
            if  not(result) then
               result := false;
               exit  For_Loop;
            end if;
         end loop For_Loop;
      end if;

      print(debug,"Transition--Evaluate_Conditions--return--" & boolean'Image(result));
      Pulse_key(debug);
      return result;

      exception
      when others =>
         print(true,"Transition--Evaluate_Conditions--" & this.Get_Name &"--exception");
         delay 10.00;
         return true;
   end Evaluate_Conditions;



end minfr.Transition;
