with minfr.Condition,
     minfr.Minfr_State,
     Ada.Containers.Vectors,
     Ada.Strings.Unbounded;

use minfr.Condition,
    minfr.Minfr_State,
    Ada.Containers,
    Ada.Strings.Unbounded;



package minfr.Transition is

   type Transition (<>) is tagged private;
   type Ptr_Transition is access Transition;
   type Index_Vector is new Natural;

   package Vector_ptr_Condition is new Vectors (Index_Vector,Ptr_Condition);
   use Vector_ptr_Condition;
   package Vector_Vector is new Vectors (Index_Vector,Vector_ptr_Condition.Vector);
   use Vector_Vector;


   ---------Constructores----------
   not overriding
   function Constr_Transition (Name : string) return Ptr_Transition;
   ----------------------------------------------------------------
   not overriding
   function Evaluate_Transition (this : Transition) return boolean;
   not overriding
   procedure Add_Conditions (this : in out Transition; vec : Vector_ptr_Condition.Vector);
   not overriding
   procedure Add_Condition (this : in out Transition; Cond : Ptr_Condition);
   not overriding
   procedure Set_State (this : in out Transition; id : State_Id);
   not overriding
   function Get_State (this : Transition) return State_Id;
   not overriding
   function Get_Name (this : Transition)return string;



private

   Debug : boolean := false;

   type Transition is tagged record
      name : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica;
      state : State_Id;
      conditions : Vector_Vector.vector;
      --vector<vector<Condition*> > conditions;???????????????????
   end record;

   not overriding
   function Evaluate_Conditions (this : Transition ; vec : Vector_ptr_Condition.Vector) return boolean;


end minfr.Transition;
