with minfr.Debug,
     Ada.Integer_Text_IO,
     Ada.Exceptions;


use minfr.Debug,
    Ada.Integer_Text_IO,
    Ada.Exceptions;


package body minfr.Activity_Processor is

   function Constr_Activity_Processor return Ptr_Activity_Processor is
   begin
       return Tmp : Ptr_Activity_Processor do
         Tmp := new Activity_Processor;
         Tmp.Actvity_Data_Protec.Protec_Set_Period(0);
         Tmp.Actvity_Data_Protec.Set_Stop_ped(true);
         Tmp.Actvity_Data_Protec.Set_Suspended(false);
         Tmp.Actvity_Data_Protec.Set_Cycles(0);
         Tmp.Actvity_Data_Protec.Set_Started(false);
         Tmp.Actvity_Data_Protec.Protec_Set_Name("NoName");
      end return;
   end Constr_Activity_Processor;


   function Constr_Activity_Processor (str : string) return Ptr_Activity_Processor is
   begin
       return Tmp : Ptr_Activity_Processor do
         Tmp := new Activity_Processor;
         Tmp.Actvity_Data_Protec.Protec_Set_Period(0);
         Tmp.Actvity_Data_Protec.Set_Stop_ped(true);
         Tmp.Actvity_Data_Protec.Set_Suspended(false);
         Tmp.Actvity_Data_Protec.Set_Cycles(0);
         Tmp.Actvity_Data_Protec.Set_Started(false);
         Tmp.Actvity_Data_Protec.Protec_Set_Name(str);
      end return;
   end Constr_Activity_Processor;

   function Get_State (this : Activity_Processor) return string is
     aux : Unbounded_string;
   begin
      aux := to_unbounded_string(this.Actvity_Data_Protec.Protec_Get_Name) & "started = " & boolean'Image(this.Actvity_Data_Protec.Get_Started)&"stopped = " & boolean'Image(this.Actvity_Data_Protec.Get_Stopped) & "suspended = " & boolean'Image(this.Actvity_Data_Protec.Get_Suspended);
      return to_string(aux);
   end Get_State;


   function Get_Name (this : Activity_Processor) return string is
   begin
      return this.Actvity_Data_Protec.Protec_Get_Name;
   end Get_Name;

   Procedure Set_Name (this : in out Activity_Processor; str :string) is
   begin
      this.Actvity_Data_Protec.Protec_Set_Name(str);
   end Set_Name ;

   function Get_Cycles (this : Activity_Processor) return type_ActPro_Cycles is
      aux : type_ActPro_Cycles;
   begin
      aux := this.Actvity_Data_Protec.Protec_Get_Cycles;
      return aux;
   end Get_Cycles;

--*******************No esta Terminada*************************
   Procedure Start (this : in out Activity_Processor; obj : Ptr_Activity_Processor ) is
   begin
      print(debug,"Activity_Processor--"& this.Get_Name &"--Start--" & obj.Get_Name);
      Pulse_key(debug);
      if not(this.Actvity_Data_Protec.Get_Stopped) then
         this.Stop;
         print(debug,"Activity_Processor--"& this.Get_Name &"--Start--" & obj.Get_Name & "--this.Stop");
      end if;
      this.Actvity_Data_Protec.Protec_Set_Period(this.Calculate_Period);
      this.Actvity_Data_Protec.Set_Cycles(0);
      this.Actvity_Data_Protec.Set_Stop_ped(false);
      print(debug,"Activity_Processor--"& this.Get_Name &"--Start--" & obj.Get_Name & "--this.Tarea := new Worker(obj)");
      this.Tarea := new Worker(obj);
   end Start;

   Procedure Suspend (this : in out Activity_Processor) is
   begin
      this.Actvity_Data_Protec.Set_Suspended(true);
      --Imprimir en pantalla
      --ss<<getName() << "--> suspend \n";
   end Suspend;
--*******************No esta Terminada*************************
   Procedure Resume (this : in out Activity_Processor) is
      Debug : Boolean := false;
   begin
      if this.Actvity_Data_Protec.Get_Suspended then
         this.Actvity_Data_Protec.Set_Suspended(false);
         print(true,"Activity_Processor--"& this.Get_Name & "proceso suspendido");
         Pulse_key(Debug);
         --pthread_cond_signal(&condSuspended);
	--ss<<getName() << "--> restore \n";
         --Imprimir en pantalla proceso suspendido
      end if;
   end Resume;

   Procedure Stop (this : in out Activity_Processor) is
      Debug : Boolean := false;
   begin
      this.Resume;
      if not(this.Actvity_Data_Protec.Get_Stopped) then
         this.Actvity_Data_Protec.Set_Stop_ped(true);
         print(true,"Activity_Processor--"& this.Get_Name & "Stop proceso en ejecucion");
         Pulse_key(Debug);
         --Imprimir en pantalla Stop proceso en ejecucion
      end if;
   end Stop;

   Procedure Set_Period (this : in out Activity_Processor; Per :type_ActPro_Period) is
   begin
      this.Actvity_Data_Protec.Protec_Set_Period(Per);
   end Set_Period;

   function Get_Period (this : Activity_Processor) return type_ActPro_Period is
   begin
      return this.Actvity_Data_Protec.Protec_Get_Period;
   end Get_Period;

   Procedure Add_Activity (this : in out Activity_Processor; Act : Ptr_State_Activity) is
   begin
      if Act /= null then
         print(debug,"Activity_Processor--"& this.Get_Name &"--Add_Activity: "& Act.Get_Name);
         Pulse_key(debug);
         this.Actvity_Data_Protec.Protec_Add_Activity(Act);
      end if;
      this.Actvity_Data_Protec.Protec_Set_Period(this.Calculate_Period);
      --print(debug,"Activity_Processor--"& this.Get_Name &"--Add_Activity--Periodo:" & type_ActPro_Period'Image(this.Calculate_Period));
      --Pulse_key(debug);
   end Add_Activity;

   Procedure Remove_Activity (this : in out Activity_Processor; Act_Id : type_ActPro_ID) is
   begin
      this.Actvity_Data_Protec.Protec_Remove_Activity(Act_Id);
   end Remove_Activity;

   Procedure Reset_Activities (this : in out Activity_Processor) is
   begin
      this.Actvity_Data_Protec.Protec_Reset_Activities;
   end Reset_Activities;

   function gcd (this : Activity_Processor; P ,Q : type_ActPro_Period) return type_ActPro_Period is
   begin
      return this.Actvity_Data_Protec.Protec_gcd(P,Q);
   end gcd;


   --------------------Privada-----------------------------------

   protected body Protec_Activity is

      function Protec_Get_Name return string is
      begin
         return to_string(Name);
      end Protec_Get_Name;

      Procedure Protec_Set_Name (str :string) is
      begin
         Name := to_unbounded_string(str);
      end Protec_Set_Name ;

      function Protec_Get_Cycles return type_ActPro_Cycles is
      begin
         return Cycles;
      end Protec_Get_Cycles;

      Procedure Protec_Set_Period (Per :type_ActPro_Period) is
      begin
         T := Per;
      end Protec_Set_Period;

      function Protec_Get_Period return type_ActPro_Period is
      begin
         return T;
      end Protec_Get_Period;

      Procedure Protec_Add_Activity (Act : Ptr_State_Activity) is
      begin
         print(debug,"Activity_Processor--Protec_Add_Activity--Act.Get_Id:" & Id_State_Activity'Image(Act.Get_Id));
         Pulse_key(debug);
         My_Activities.Insert(type_ActPro_ID(Act.Get_Id),Act);
      end Protec_Add_Activity;

      Procedure Protec_Remove_Activity (Act_Id : type_ActPro_ID) is
         it : tabla.Cursor;
      begin
         it := My_Activities.Find(Act_Id);
         if it /= My_Activities.Last then
            My_Activities.Delete(it);
         end if;
         Protec_Set_Period(Protec_Calculate_Period);
      end Protec_Remove_Activity;

      Procedure Protec_Reset_Activities is
      begin
         My_Activities.Clear;
      end Protec_Reset_Activities;

      function Protec_Calculate_Period return type_ActPro_Period is
         flag : boolean :=true;
         it : tabla.Cursor;
         P : type_ActPro_Period := 0;
         P1 : type_ActPro_Period;
      begin
         if My_Activities.Length = 0 then
            flag := false;
         end if;
         if flag then
            it := My_Activities.First;
            P := type_ActPro_Period(Element(it).Get_Period);
            print(true,"Activity_Processor1--"& Protec_Get_Name &"--Protec_Calculate_Period--Activity--" & Element(it).Get_Name & "--Periodo:" &  type_ActPro_Period'Image(P));
            while it /= My_Activities.Last loop
               next(it);
               P1 := type_ActPro_Period(Element(it).Get_Period);
               print(true,"Activity_Processor2--"& Protec_Get_Name &"--Protec_Calculate_Period--Activity--" & Element(it).Get_Name & "--Periodo:" &  type_ActPro_Period'Image(P1));
               P := Protec_gcd(P,P1);
               print(true,"Activity_Processor3--"& Protec_Get_Name &"--Protec_Calculate_Period--gcd(P,P1):" &  type_ActPro_Period'Image(P));
            end loop;
         end if;
         print(true,"Activity_Processor4--"& Protec_Get_Name &"--Protec_Calculate_Period--gcd(P,P1):" &  type_ActPro_Period'Image(P));
         Pulse_key(debug);
         return P;
      end Protec_Calculate_Period;

      function Protec_gcd (P ,Q : type_ActPro_Period) return type_ActPro_Period is
      begin
         if Q = 0 then
            return P ;
         else
            return Protec_gcd (Q,P rem Q);
         end if;
      end Protec_gcd;



      ------------------Protegidas-----------------------------

      function Get_Stopped return boolean  is
      begin
         return Stop_ped;
      end Get_Stopped;

      Procedure Set_Stop_ped (bool : boolean)  is
      begin
         Stop_ped := bool;
      end Set_Stop_ped;

      function Get_Suspended return boolean  is
      begin
         return Suspended;
      end Get_Suspended;

      Procedure Set_Suspended (bool : boolean)  is
      begin
         Suspended := bool;
      end Set_Suspended;

      Procedure Set_Cycles (Cycle : type_ActPro_Cycles)  is
      begin
         Cycles := Cycle;
      end Set_Cycles;

      function Get_Started return boolean  is
      begin
         return Star_ted;
      end Get_Started;

      Procedure Set_Started (bool : boolean)  is
      begin
        Star_ted := bool;
      end Set_Started;

      -------------------------------------------------

      function Begin_My_Activities return tabla.Cursor is
      begin
         return My_Activities.First;
      end  Begin_My_Activities;

      function Last_My_Activities return tabla.Cursor is
      begin
         return My_Activities.Last;
      end Last_My_Activities;

      function Element_My_Activities (iter : tabla.Cursor ) return Ptr_State_Activity is
      begin
         return Element(iter);
      end Element_My_Activities;

      Procedure Length_My_Activities is
         iter : tabla.Cursor;
         debug : boolean := false;
      begin
         print(debug,"Activity_Processor--"& Protec_Get_Name &"--Length_My_Activities--" & Count_Type'Image(My_Activities.Length));
      end Length_My_Activities;

      Procedure Print_Table_My_Activities is
         iter : tabla.Cursor;
         debug : boolean := false;
      begin
         iter := My_Activities.First;
         if iter /= No_Element then
            print(debug,"Print_Table_My_Activities");
            Bloque_loop:
            loop
               print(debug,"Element:" & Element(iter).Get_Name);
               Minfr_State.Hierarchical_State.Hierarchical_Activity(Element(iter).all).Print_Region_State;
               next(iter);
               exit Bloque_loop when iter = No_Element;
            end loop Bloque_loop;
         end if;
      end Print_Table_My_Activities;

   end Protec_Activity;

   function Calculate_Period (this : Activity_Processor) return type_ActPro_Period  is
   begin
      return this.Actvity_Data_Protec.Protec_Calculate_Period;
   end Calculate_Period;

   Procedure Chage_State (this : Activity_Processor; Pt_Bool : access boolean; bool : boolean) is --puntero de una tarea
   begin
      null;
   end Chage_State;

   Procedure Run (this : in out Activity_Processor)  is

      type T_Real is digits 16;
      type T_Real_Fijo is delta 0.000001 digits 16;
      ------------------------
      Ini_Time,F_Time : Time;
      Timer: Time:= Clock;
      Elapsed_Time,Sleep_Time : Time_Span;
      iter : tabla.Cursor;
      debug : boolean := false;
      -------------------------
      F_Time_1,Ini_Time_1: Time;
      Timer_1,Timer_2,Timer_3 : Time_Span;
      Sc_Time_1,Sc_Time_2 : Seconds_Count;
      --Float1,Float2 : T_Real;
      --Real_Fijo_1,Real_Fijo_2,Real_Fijo_3,Real_Fijo_4 : T_Real_Fijo;

      -------------------------
      --P_Time_CPU : Time_Span;
      --Ini_Time_CPU,F_Time_CPU : CPU_Time;
      --Sc : Seconds_Count;
      -------------------------
   begin



      --print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Get_Name & "--Inicio");
      Pulse_key(debug);
      this.Actvity_Data_Protec.Set_Started(True);
      print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Get_Name & "--Stopped:" & boolean'Image(this.Actvity_Data_Protec.Get_Stopped));
      Pulse_key(debug);
      while not(this.Actvity_Data_Protec.Get_Stopped) loop
         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Get_Name & "--Stopped:" & boolean'Image(this.Actvity_Data_Protec.Get_Stopped));
         --Ini_Time_CPU := Clock;
         Ini_Time_1 := Clock;
         delay until Timer;
         Ini_Time := Clock;
         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Get_Name & "--Suspended:" & boolean'Image(this.Actvity_Data_Protec.Get_Suspended));
         Pulse_key(debug);
         while this.Actvity_Data_Protec.Get_Suspended loop null; end loop;
         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Get_Name & "--Suspended:" & boolean'Image(this.Actvity_Data_Protec.Get_Suspended));
         Pulse_key(debug);
         iter := this.Actvity_Data_Protec.Begin_My_Activities;
         --this.Actvity_Data_Protec.Length_My_Activities;
         --this.Actvity_Data_Protec.Print_Table_My_Activities;
         Pulse_key(debug);
         Bloque_loop:
         loop
            print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Name Actividad:" & this.Actvity_Data_Protec.Element_My_Activities(iter).Get_Name);
            Pulse_key(debug);
            --if Minfr_State.Hierarchical_State.Ptr_Hierarchical_Activity.all(this.Actvity_Data_Protec.Element_My_Activities(iter)).Can_Execute then
            if Minfr_State.Hierarchical_State.Hierarchical_Activity(this.Actvity_Data_Protec.Element_My_Activities(iter).all).Can_Execute then
               print(debug,"Activity_Processor--"& this.Get_Name &"--Run--" & this.Actvity_Data_Protec.Element_My_Activities(iter).Get_Name & ".Execute_Tick");
               Pulse_key(debug);
               this.Actvity_Data_Protec.Element_My_Activities(iter).Execute_Tick;
            end if;
            --if iter /= No_Element
            --print(debug,"Activity_Processor--"& this.Get_Name &"--Run--iter:" & Cursor'Image(iter));
            --Pulse_key(debug);
            next(iter);
            print(debug,"Activity_Processor--"& this.Get_Name &"--Run--exit Bloque??");
            Pulse_key(debug);
            --exit Bloque_loop when iter = this.Actvity_Data_Protec.Last_My_Activities;
            exit Bloque_loop when iter = No_Element;
            print(debug,"Activity_Processor--"& this.Get_Name &"--Run--next" & this.Actvity_Data_Protec.Element_My_Activities(iter).Get_Name);
            Pulse_key(debug);
            --next(iter);
            --print(debug,"Activity_Processor--"& this.Get_Name &"--Run--next" & this.Actvity_Data_Protec.Element_My_Activities(iter).Get_Name);
            --Pulse_key(debug);
         end loop Bloque_loop;

         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--exit Bloque_loop");



--           if Print_Activity_Processor then Put("Activity_Processor--Run--Paso4");New_Line;end if;
         this.Actvity_Data_Protec.Set_Cycles(this.Actvity_Data_Protec.Protec_Get_Cycles+1);


         F_Time := Clock;
--           Split(F_Time,aux_Seconds,aux_Time_Span);
--
--           print(debug,"Activity_Processor--Run--F_Time = " & Seconds_Count'Image(aux_Seconds));
--           Pulse_key(debug);
--           Split(Ini_Time,aux_Seconds,aux_Time_Span);
--           print(debug,"Activity_Processor--Run--Ini_Time = " & integer'Image(integer(aux_Seconds)));
--           Pulse_key(debug);
         Elapsed_Time := F_Time - Ini_Time;


         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Elapsed_Time= " & integer'Image(integer(To_Duration(Elapsed_Time *1000000))));
         Pulse_key(debug);


         print(debug,"Activity_Processor--Run--Protec_Get_Period = " & integer'Image(integer(this.Actvity_Data_Protec.Protec_Get_Period)));
         Pulse_key(debug);

         print(debug,"Period : " & integer'Image(integer(this.Actvity_Data_Protec.Protec_Get_Period)));
         print(debug,"Period : " & integer'Image(integer(To_Duration(Milliseconds(integer(this.Actvity_Data_Protec.Protec_Get_Period*1000000))))));
         Pulse_key(debug);

         Sleep_Time := Milliseconds(integer(this.Actvity_Data_Protec.Protec_Get_Period))-(Elapsed_Time);
         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Sleep_Time= " & integer'Image(integer(To_Duration(Sleep_Time *1000000))));
         Pulse_key(debug);

         if (Sleep_Time < Seconds(0)) then
            print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Sleep_Time < 0 ");
            Pulse_key(debug);
            Sleep_Time := Seconds(0);
         end if;

         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Sleep_Time= " & integer'Image(integer(To_Duration(Sleep_Time *1000))));
         Pulse_key(debug);



         --delay To_Duration(Sleep_Time);

         print(debug,"Activity_Processor--"& this.Get_Name &"--Run--Repit");
         Pulse_key(debug);


         --Timer_1 := F_Time_1 - Ini_Time_1;
         --F_Time_CPU := Clock;
         --P_Time_CPU := F_Time_CPU - Ini_Time_CPU;
         --Split(F_Time_CPU,Sc,P_Time_CPU);
         --print(true,"Activity_Processor--"& this.Get_Name & "--Timer : " & Float'Image(Float(Sc)));
        -- print(true,"Activity_Processor--"& this.Get_Name & "--Timer : " & integer'Image(integer(To_Duration(P_Time_CPU *1000000))));
         --print_Fichero (this.Get_Name & ".txt",integer'Image(integer(To_Duration(Timer_1 *1000000))),1);
        --print_Fichero (this.Get_Name & ".txt",time'Image(F_Time_1),1);
         Split(Ini_Time_1,Sc_Time_1,Timer_2);
         --print(true,"Ini_Time_1_Sc_Time : " & Seconds_Count'Image(Sc_Time) & " Ini_Time_1_Time_Span : " & integer'Image(integer(To_Duration(Timer_2 *1000000))));
         F_Time_1 := Clock;
         Split(F_Time_1,Sc_Time_2,Timer_3);



         print_Fichero(this.Get_Name & "Ini.txt",T_Real_Fijo'Image(T_Real_Fijo(Sc_Time_1)+T_Real_Fijo(To_Duration(Timer_2))),0);
         print_Fichero(this.Get_Name & "Fin.txt",T_Real_Fijo'Image(T_Real_Fijo(Sc_Time_2)+T_Real_Fijo(To_Duration(Timer_3))),0);


         --print(true,"Ini_Time : " & Seconds_Count'Image(Sc_Time_1) & "," & integer'Image(integer(To_Duration(Timer_2 *1000000))));
         --print(true," F_Time_1 : " & Seconds_Count'Image(Sc_Time_2) &  "," & integer'Image(integer(To_Duration(Timer_3 *1000000))));
         --print_Fichero(this.Get_Name & "Ini.txt",Seconds_Count'Image(Sc_Time_1) & "," & integer'Image(integer(To_Duration(Timer_2*1000000))),0);
         --print_Fichero(this.Get_Name & "Fin.txt",Seconds_Count'Image(Sc_Time_2) & "," & integer'Image(integer(To_Duration(Timer_3*1000000))),0);
         --float1:=T_Real(Sc_Time_1)+ T_Real(To_Duration(Timer_2*1000000));
         --float2:=T_Real(Sc_Time_2)+T_Real(To_Duration(Timer_3*1000000));
         --print_Fichero(this.Get_Name & "Ini.txt",T_Real'Image(float1),0);
         --print_Fichero(this.Get_Name & "Fin.txt",T_Real'Image(float2),0);

         --print_Fichero(this.Get_Name & "Ini0.txt" ,Seconds_Count'Image(Sc_Time_1),0);
         --print_Fichero(this.Get_Name & "Ini1.txt" ,integer'Image(integer(To_Duration(Timer_2 *1000000))),0);

         --print_Fichero(this.Get_Name & "Fin0.txt" ,Seconds_Count'Image(Sc_Time_2),0);
         --print_Fichero(this.Get_Name & "Fin1.txt" ,integer'Image(integer(To_Duration(Timer_3 *1000000))),0);
         Timer := Timer + Sleep_Time;

      end loop;

   exception
      when Error: others =>
         print(true,"Activity_Processor--run--"& this.Get_Name &"--exception: " & Exception_Information(Error));
         Pulse_key(debug);



   end Run;


   -----------Cuerpo de la tarea---------------------
   task body Worker is

   begin
      actp.My_Thread_ID := Current_Task;
      print(debug,"Activity_Processor--Worker--" & actp.Get_Name & "--Inicio");
      if actp /= null then
         print(debug,"Activity_Processor--Worker--" & actp.Get_Name & "--actp.Run");
         actp.Run;
      end if;
      print(debug,"Activity_Processor--Worker--" & actp.Get_Name & "--Fin");

   exception
      when Error: others =>
         print(true,"Activity_Processor--Worker--"& actp.Get_Name &"--exception : " & Exception_Information(Error));
         Pulse_key(debug);

   end Worker;

end minfr.Activity_Processor;
