with Ada.Text_IO,
     MinFr.Activity_Processor,
     Minfr.Minfr_State,
     Minfr.Minfr_State.Leaf_State,
     Minfr.Minfr_State.Hierarchical_State,
     Minfr.Minfr_State.Hierarchical_State.Region,
     Minfr.State_Activity,
     Minfr.State_Activity.Leaf_Activity.First_Activity,
     Minfr.State_Activity.Leaf_Activity.Start_Activity,
     minfr.MinFr_Component_Data,
     minfr.MinFr_Component_Data.MinFr_Data,
     minfr.MinFr_Component,
     minfr.MinFr_Component.Component,
     minfr.Transition,
     minfr.Condition,
     minfr.Condition.Condition_Event,
     minfr.MinFr_Port,
     minfr.MSG.Minfr_Msg,
     minfr.Msg_aux;

use Ada.Text_IO,
    MinFr.Activity_Processor,
    Minfr.Minfr_State,
    Minfr.Minfr_State.Leaf_State,
    Minfr.Minfr_State.Hierarchical_State,
    Minfr.Minfr_State.Hierarchical_State.Region,
    Minfr.State_Activity,
    Minfr.State_Activity.Leaf_Activity.First_Activity,
    Minfr.State_Activity.Leaf_Activity.Start_Activity,
    minfr.MinFr_Component_Data,
    minfr.MinFr_Component_Data.MinFr_Data,
    minfr.MinFr_Component,
    minfr.MinFr_Component.Component,
    minfr.Transition,
    minfr.Condition,
    minfr.Condition.Condition_Event,
    minfr.MinFr_Port,
    minfr.MSG.Minfr_Msg,
    minfr.Msg_aux;

procedure minfr.Main_Activity is


   data_1 : P_MinFr_Data :=  Constr_MinFr_Data ("data-C1");
   data_2 : P_MinFr_Data :=  Constr_MinFr_Data ("data-C2");
   Vec_State_C1 : Vector_ptr_Minfr_State.Vector;
   Vec_State_C2 : Vector_ptr_Minfr_State.Vector;

   Port_InA :  Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port(2,1,"InputA",data_1);
   Port_OutA : Ptr_MinFr_OutPut_Port := Constr_MinFr_OutPut_Port(1,1,"OutputA");
   Port_InB :  Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port(1,2,"InputB",data_2);
   Port_OutB : Ptr_MinFr_OutPut_Port := Constr_MinFr_OutPut_Port(2,2,"OutputB");

   State_1_R1_C1 : Ptr_Leaf_State := Constr_Leaf_State (1,"State_1_R1_C1");
   State_2_R1_C1 : Ptr_Leaf_State := Constr_Leaf_State (2,"State_2_R1_C1");

   State_1_R1_C2 : Ptr_Leaf_State := Constr_Leaf_State (1,"State_1_R1_C2");
   --State_2_R1_C2 : Ptr_Leaf_State := Constr_Leaf_State (2,"State_2_R1_C2");

   Trasicion_State_1_R1_C1 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R1_C1");
   Trasicion_State_2_R1_C1 : Ptr_Transition := Constr_Transition("Trasicion_State_2_R1_C1");
   Trasicion_State_1_R1_C2 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R1_C2");

   Vec_Condi_State_1_R1_C1 : Vector_ptr_Condition.Vector;
   Vec_Condi_State_2_R1_C1 : Vector_ptr_Condition.Vector;
   Vec_Condi_State_1_R1_C2 : Vector_ptr_Condition.Vector;


   Condition_Event_St1_2_C1 : Ptr_Condition_Event := Constr_Condition_Event (data_1,"St1-2",false);
   Condition_Event_St2_2_C1 : Ptr_Condition_Event := Constr_Condition_Event (data_1,"St2-2",false);
   Condition_Event_St1_1_C2 : Ptr_Condition_Event := Constr_Condition_Event (data_2,"St2-2",false);

   Componente_1 : Ptr_Component := Constr_Component (1,"Componente_1", Ptr_MinFr_Component_Data(data_1));
   Componente_2 : Ptr_Component := Constr_Component (2,"Componente_2", Ptr_MinFr_Component_Data(data_2));

--     St_Start_C1 : Ptr_Start_Activity := Constr_Start_Activity (1,Ptr_MinFr_Component(Componente_1));
--     St_First_C1 : Ptr_First_Activity := Constr_First_Activity (1,Ptr_MinFr_Component(Componente_1));
--     St_First_C2 : Ptr_First_Activity := Constr_First_Activity (1,Ptr_MinFr_Component(Componente_2));

   St_Start_C1 : Ptr_Start_Activity;
   St_First_C1 : Ptr_First_Activity;
   St_First_C2 : Ptr_First_Activity;

   Activity_C1 : Ptr_Activity_Processor := Constr_Activity_Processor;
   Activity_C2 : Ptr_Activity_Processor := Constr_Activity_Processor;



   HA_C1 : Ptr_Hierarchical_Activity;
   HA_C2 : Ptr_Hierarchical_Activity;

   Region_1_C_1 : Ptr_Region;
   Region_1_C_2 : Ptr_Region;

   Id : LastTable_Id:=0;
   --msg : Ptr_Minfr_Msg := Constr_Minfr_Msg;
begin

                                                                      --Trak A                Trak B
                                                                     -----------|   <--    |-----------
   Port_OutA.Set_Conjugate(Ptr_MinFr_Port(Port_InB));                --    OA --|--> -- >--|-- IB
                                                                     --    IA --|--< -- <--|-- OB
   Port_OutB.Set_Conjugate(Ptr_MinFr_Port(Port_InA));	    	     -----------|    -->   |-----------

--     Put_Line("ID_Port_OutA =" & Port_ID'Image(Port_OutA.Get_Unique_Id));
--     Put_Line("ID_Port_OutB =" & Port_ID'Image(Port_OutB.Get_Unique_Id));
--     Put_Line("ID_Port_InA =" & Port_ID'Image(Port_InA.Get_Unique_Id));
--     Put_Line("ID_Port_InB =" & Port_ID'Image(Port_InB.Get_Unique_Id));
--     delay 20.0;


   data_1.Subscribe_To_InPort_Msg(Port_InA.Get_Name,Id);
   data_2.Subscribe_To_InPort_Msg(Port_InB.Get_Name,Id);


   Componente_1.Add_Port(Ptr_MinFr_Port(Port_InA));
   Componente_1.Add_Port(Ptr_MinFr_Port(Port_OutA));
   Componente_2.Add_Port(Ptr_MinFr_Port(Port_InB));
   Componente_2.Add_Port(Ptr_MinFr_Port(Port_OutB));

   St_Start_C1 := Constr_Start_Activity (1,Ptr_MinFr_Component(Componente_1));
   St_First_C1 := Constr_First_Activity (1,Ptr_MinFr_Component(Componente_1));
   St_First_C2 := Constr_First_Activity (1,Ptr_MinFr_Component(Componente_2));

   St_Start_C1.Set_Name("St_Start");
   Vec_Condi_State_1_R1_C1.Append(Ptr_Condition(Condition_Event_St1_2_C1));
   Trasicion_State_1_R1_C1.Add_Conditions(Vec_Condi_State_1_R1_C1);
   --Trasicion_State_1_R1_C1.Add_Condition(Ptr_Condition(Condition_Event_St1_2_C1));
   Trasicion_State_1_R1_C1.Set_State(State_Id(State_2_R1_C1.Get_Id));
   State_1_R1_C1.Set_Activity(Ptr_State_Activity(St_Start_C1));
   State_1_R1_C1.Add_Transition(Trasicion_State_1_R1_C1);


   St_First_C1.Set_Name("St_First");
   Vec_Condi_State_2_R1_C1.Append(Ptr_Condition(Condition_Event_St2_2_C1));
   Trasicion_State_2_R1_C1.Add_Conditions(Vec_Condi_State_2_R1_C1);
   --Trasicion_State_1_R1_C1.Add_Condition(Ptr_Condition(Condition_Event_St2_2_C1));
   Trasicion_State_2_R1_C1.Set_State(State_Id(State_2_R1_C1.Get_Id));
   State_2_R1_C1.Set_Activity(Ptr_State_Activity(St_First_C1));
   State_2_R1_C1.Add_Transition(Trasicion_State_2_R1_C1);



   Vec_State_C1.Append(Minfr_State_Ptr(State_1_R1_C1));
   Vec_State_C1.Append(Minfr_State_Ptr(State_2_R1_C1));
   Region_1_C_1 := Constr_Region(data_1,"Region_1_C_1",Vec_State_C1,1,1);



   HA_C1 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_1_C_1));
   HA_C1.Set_Name("Hierachical-Activity-Componente1");
   HA_C1.Set_Period(10);

   Activity_C1.Add_Activity(Ptr_State_Activity(HA_C1));
   Activity_C1.Set_Name("Activity-Componente1");

   St_First_C2.Set_Name("St_First");
   Vec_Condi_State_1_R1_C2.Append(Ptr_Condition(Condition_Event_St1_1_C2));
   Trasicion_State_1_R1_C2.Add_Conditions(Vec_Condi_State_1_R1_C2);
   --Trasicion_State_1_R1_C2.Add_Condition(Ptr_Condition(Condition_Event_St1_1_C2));
   Trasicion_State_1_R1_C2.Set_State(State_Id(State_1_R1_C2.Get_Id));
   State_1_R1_C2.Set_Activity(Ptr_State_Activity(St_First_C2));
   State_1_R1_C2.Add_Transition(Trasicion_State_1_R1_C2);

   Vec_State_C2.Append(Minfr_State_Ptr(State_1_R1_C2));
   Region_1_C_2 := Constr_Region(data_2,"Region_1_C_2",Vec_State_C2,1,1);

   HA_C2 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_1_C_2));
   HA_C2.Set_Name("Hierachical-Activity-Componente2");
   HA_C2.Set_Period(10);

   Activity_C2.Add_Activity(Ptr_State_Activity(HA_C2));
   Activity_C2.Set_Name("Activity-Componente2");


   Activity_C1.Start(Activity_C1);
   Activity_C2.Start(Activity_C2);
--     Put("Retardo de 2Seg");
--     New_Line;
--     delay 2.0;
--     Activity.Resume;
--     Put("Start Activity");
--     New_Line;
   --Activity.Resume;






--
--                                                                      --Trak A                Trak B
--                                                                     -----------|   <--    |-----------
--     Port_OutA.Set_Conjugate(Ptr_MinFr_Port(Port_InB));              --    OA --|--> -- >--|-- IB
--                                                                     --    IA --|--< -- <--|-- OB
--     Port_OutB.Set_Conjugate(Ptr_MinFr_Port(Port_InA));	       -----------|    -->   |-----------
--
--     data_1.Subscribe_To_InPort_Msg(Port_InA.Get_Name,Id);
--     data_2.Subscribe_To_InPort_Msg(Port_InB.Get_Name,Id);
--
--
--     Vec_State_C1.Append(Minfr_State_Ptr(State_1_R1_C1));
--     Vec_State_C1.Append(Minfr_State_Ptr(State_2_R1_C1));
--
--     Vec_State_C2.Append(Minfr_State_Ptr(State_1_R1_C2));
--     Vec_State_C2.Append(Minfr_State_Ptr(State_2_R1_C2));
--
--     Region_1_C_1 := Constr_Region(data_1,"Region_1_C_1",Vec_State_C1,1,1);
--     Region_1_C_2 := Constr_Region(data_2,"Region_1_C_2",Vec_State_C2,1,1);
--
--     Componente_1.Add_Region(Ptr_Hierarchical_State(Region_1_C_1));
--     Componente_2.Add_Region(Ptr_Hierarchical_State(Region_1_C_2));
--
--     Componente_1.Add_Port(Ptr_MinFr_Port(Port_InA));
--     Componente_1.Add_Port(Ptr_MinFr_Port(Port_OutA));
--     Componente_2.Add_Port(Ptr_MinFr_Port(Port_InB));
--     Componente_2.Add_Port(Ptr_MinFr_Port(Port_OutB));
--
--     Activity.Add_Activity(Ptr_State_Activity(HA));
   --Put("Fin1");
   --New_Line;
end minfr.Main_Activity;
