with minfr.Debug;

use minfr.Debug;

package body minfr.MinFr_Component.Component is

    -----------------------Constructores-----------------------------
   function Constr_Component (Id : State_Id; name : string; compData : Ptr_MinFr_Component_Data) return Ptr_Component is
   begin
       return Tmp :Ptr_Component do
         Tmp := new Component;
         Tmp.Name := to_unbounded_string(name);
         Tmp.Unique_Id := Id;
         Tmp.Comp_Data := compData;
         Tmp.Protec_Comp_Data := new Protec_Component; -- Hay que crear el objerto protegido
      end return;
   end Constr_Component;

   -----------------------------------------------------------------
   -----------------------MinFr_Component-----------------------------

   procedure Set_ME (This : Component; me : Minfr_State_Ptr) is
   begin
      null;
   end Set_ME;
---------------------Mirar si esto es lo que hay que hacer----------------
   function Get_Activities (This : Component) return Pack_Vector.List is
   begin
      return This.Protec_Comp_Data.Protec_Get_Activities;
   end Get_Activities;

   function Get_Component_Name (This : Component) return string is
   begin
      return To_string(this.Name);
   end Get_Component_Name;

   function Get_Ports (This : Component) return Pack_Orde_Maps_Port.Map is
   begin
      return This.Protec_Comp_Data.Protec_Get_Ports;
   end Get_Ports;

   function Get_Port_In (This : Component) return Ptr_MinFr_Input_Port is
   begin
      return This.Protec_Comp_Data.Protec_Get_Port_In;
   end Get_Port_In;

   function Get_Port_Out (This : Component) return Ptr_MinFr_OutPut_Port is
   begin
      return This.Protec_Comp_Data.Protec_Get_Port_Out;
   end Get_Port_Out;

   procedure Add_Port (This : in out Component; Port : Ptr_MinFr_Port) is
   begin
      This.Protec_Comp_Data.Protec_Add_Port(Port);
   end Add_Port;

   procedure Add_Region (This : in out Component; Region :  Ptr_Hierarchical_State) is
   begin
      This.Protec_Comp_Data.Protec_Add_Region(Region);
   end Add_Region;

   function Get_Region (This : Component;Id : State_Id) return Ptr_Hierarchical_State is
   begin
      return This.Protec_Comp_Data.Protec_Get_Region(Id);
   end Get_Region;

   function Get_Unique_Id (This : Component) return State_Id is
   begin
      return This.Unique_Id;
   end Get_Unique_Id;

   function Get_Component_Data (This : Component) return Ptr_MinFr_Component_Data is
   begin
      return This.Comp_Data;
   end Get_Component_Data;

   protected body Protec_Component is

      function Protec_Get_Activities return Pack_Vector.List is
         Ca : Pack_Vector.List;
         --iter : Pack_Orde_Maps_Regions.Map;
         iter : Pack_Orde_Maps_Regions.Cursor;
      begin
         iter := My_Regions.First; ---Posicion del primer elemento de la hast-table
         while  Element(iter) /= My_Regions.Last_Element loop
            Ca.Append(Element(iter).Get_Activity); -- Aade un elemento a la lista
            next(iter);
         end loop;
         Ca.Append(Element(My_Regions.Last).Get_Activity);-- Aade el ultimo elemento a la lista
         return Ca;
      end Protec_Get_Activities;

      function Protec_Get_Ports return Pack_Orde_Maps_Port.Map is
      begin
         return Ports;
      end Protec_Get_Ports;


      function Protec_Get_Port_In return Ptr_MinFr_Input_Port is
         iter : Pack_Orde_Maps_Port.Cursor;
         Port_In :  Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port;
         Port : Ptr_MinFr_Port;
      begin
         iter := Ports.First; ---Posicion del primer elemento de la hast-table
          B_loop:
         loop
            print(debug,"Component--Protec_Get_Port_In--B_loop");
            Pulse_key(debug);

            Port := element(iter);

            print(debug,"Component--Protec_Get_Port_In--Port.Get_Name--" & Port.Get_Name);
            Pulse_key(debug);
            print(debug,"Component--Protec_Get_Port_In--Port.Get_Name--" & Port_In.Get_Name);
            Pulse_key(debug);

            if Port'Tag = Ptr_MinFr_Port(Port_In)'Tag then
               print(debug,"Component--Protec_Get_Port_In--Ptr_MinFr_Input_Port");
               Pulse_key(debug);
               Port_In := Ptr_MinFr_Input_Port(Port);
               print(debug,"Component--Protec_Get_Port_In--Port_In.Get_Name"  & Port_In.Get_Name);
               Pulse_key(debug);
               exit B_loop;
            end if;
            print(debug,"Component--Protec_Get_Port_In--next(iter)");
            Pulse_key(debug);
            next(iter);
            if iter = Pack_Orde_Maps_Port.No_Element then
               Port_In := null;
               exit B_loop;
            end if;
            print(debug,"Component--Protec_Get_Port_In--next-loop");
            Pulse_key(debug);
         end loop B_loop;
         return Port_In;
      end Protec_Get_Port_In;

      function Protec_Get_Port_Out return Ptr_MinFr_Output_Port is
         iter : Pack_Orde_Maps_Port.Cursor;
         Port_Out :  Ptr_MinFr_Output_Port := Constr_MinFr_Output_Port;
         Port : Ptr_MinFr_Port;
      begin
         iter := Ports.First; ---Posicion del primer elemento de la hast-table
         B_loop:
         loop
            print(debug,"Component--Protec_Get_Port_Out--B_loop");
            Pulse_key(debug);
            Port := element(iter);
            print(debug,"Component--Protec_Get_Port_Out--Port.Get_Name--" & Port.Get_Name);
            Pulse_key(debug);
            if Port'Tag = Ptr_MinFr_Port(Port_Out)'Tag then
               print(debug,"Component--Protec_Get_Port_Out--Ptr_MinFr_Input_Port");
               Pulse_key(debug);
               Port_Out := Ptr_MinFr_Output_Port(Port);
               print(debug,"Component--Protec_Get_Port_Out--Port_In.Get_Name"  & Port_Out.Get_Name);
               Pulse_key(debug);
               exit B_loop;
            end if;
            print(debug,"Component--Protec_Get_Port_Out--next(iter)");
            Pulse_key(debug);
            next(iter);
            if iter = Pack_Orde_Maps_Port.No_Element then
               Port_Out := null;
               exit B_loop;
            end if;
            print(debug,"Component--Protec_Get_Port_Out--next-loop");
            Pulse_key(debug);
         end loop B_loop;
         return Port_Out;
      end Protec_Get_Port_Out;

      procedure Protec_Add_Port (Port : Ptr_MinFr_Port) is
      begin
         Ports.Insert(Key_Type_Map(Port.Get_Unique_Id),Port);
      end Protec_Add_Port;

      procedure Protec_Add_Region (Region :  Ptr_Hierarchical_State)  is
      begin
         My_Regions.Insert(Key_Type_Map(Region.Get_Id),Region);
      end Protec_Add_Region;

      function Protec_Get_Region (Id : State_Id) return Ptr_Hierarchical_State is
      begin
         return Element(My_Regions.Find(Key_Type_Map(Id)));
      end Protec_Get_Region;

   end Protec_Component;


end minfr.MinFr_Component.Component;
