with Ada.Strings.Unbounded,
     Ada.Tags;

use Ada.Strings.Unbounded,
    Ada.Tags;

package minfr.MinFr_Component.Component is


   type Component (<>) is new MinFr_Component with private;

   type Ptr_Component is access Component;

   -----------------------Constructores-----------------------------
   not overriding
   function Constr_Component (Id : State_Id; name : string; compData : Ptr_MinFr_Component_Data) return Ptr_Component;
   -----------------------------------------------------------------
   -----------------------MinFr_Component-----------------------------
   overriding
   procedure Set_ME (This : Component; me : Minfr_State_Ptr);
   overriding
   function Get_Activities (This : Component) return Pack_Vector.List;
   overriding
   function Get_Component_Name (This : Component) return string;
   overriding
   function Get_Ports (This : Component) return Pack_Orde_Maps_Port.Map;
   overriding
   function Get_Port_In (This : Component) return Ptr_MinFr_Input_Port;
   overriding
   function Get_Port_Out (This : Component) return Ptr_MinFr_OutPut_Port;
   overriding
   procedure Add_Port (This : in out Component; Port : Ptr_MinFr_Port);
   overriding
   procedure Add_Region (This : in out Component; Region :  Ptr_Hierarchical_State);
   overriding
   function Get_Region (This : Component;Id : State_Id) return Ptr_Hierarchical_State;--Id ha de ser un State_Id??????
   overriding
   function Get_Unique_Id (This : Component) return State_Id;--return ha de ser un State_Id??????
   overriding
   function Get_Component_Data (This : Component) return Ptr_MinFr_Component_Data;



private

   Debug : Boolean := False;

   package Pack_Orde_Maps_Regions is new Ada.Containers.Ordered_Maps(Key_Type => Key_Type_Map,
                                                                 Element_Type => Ptr_Hierarchical_State,
                                                                  "<" => "<");
   use Pack_Orde_Maps_Regions;

   protected type Protec_Component is
      not overriding
      function Protec_Get_Activities return Pack_Vector.List;
      not overriding
      function Protec_Get_Ports return Pack_Orde_Maps_Port.Map;
      not overriding
      function Protec_Get_Port_In return Ptr_MinFr_Input_Port;
      not overriding
      function Protec_Get_Port_Out return Ptr_MinFr_Output_Port;
      not overriding
      procedure Protec_Add_Port (Port : Ptr_MinFr_Port);
      not overriding
      procedure Protec_Add_Region (Region :  Ptr_Hierarchical_State);
      not overriding
      function Protec_Get_Region (Id : State_Id) return Ptr_Hierarchical_State;
   private
      My_Regions : Pack_Orde_Maps_Regions.Map;
      Ports : Pack_Orde_Maps_Port.Map;
   end Protec_Component;

   type Ptr_Protec_Component is access Protec_Component;
   --Protec_Comp_Data : Protec_Component;


   type Component is new MinFr_Component with record
      Protec_Comp_Data : Ptr_Protec_Component;
      Name : Unbounded_String;
      Unique_Id : State_Id; --Tiene que ser State_Id
      Comp_Data : Ptr_MinFr_Component_Data;
   end record;

end minfr.MinFr_Component.Component;
