with Ada.Containers.Doubly_Linked_Lists,
     Ada.Containers.Ordered_Maps,
     minfr.Minfr_State,
     minfr.Minfr_State.Hierarchical_State,
     minfr.State_Activity,
     minfr.MinFr_Port,
     minfr.MinFr_Component_Data;

use Ada.Containers,
    minfr.Minfr_State,
    minfr.State_Activity,
    minfr.Minfr_State.Hierarchical_State,
    minfr.MinFr_Port,
    minfr.MinFr_Component_Data;

package minfr.MinFr_Component is

   type MinFr_Component is interface;
   type Ptr_MinFr_Component is access all MinFr_Component'Class;

   type Key_Type_Map is new Natural;

   package Pack_Vector is new Ada.Containers.Doubly_Linked_Lists(Ptr_State_Activity);
   use Pack_Vector;
   package Pack_Orde_Maps_Port is new Ada.Containers.Ordered_Maps(Key_Type => Key_Type_Map,
                                                              Element_Type => Ptr_MinFr_Port,
                                                              "<" => "<");
   use Pack_Orde_Maps_Port;


   not overriding
   procedure Set_ME (This : MinFr_Component; me : Minfr_State_Ptr) is abstract;
   not overriding
   function Get_Activities (This : MinFr_Component) return Pack_Vector.List is abstract;
   not overriding
   function Get_Component_Name (This : MinFr_Component) return string is abstract;
   not overriding
   function Get_Ports (This : MinFr_Component) return Pack_Orde_Maps_Port.Map is abstract;
   not overriding
   function Get_Port_In (This : MinFr_Component) return Ptr_MinFr_Input_Port is abstract;
   not overriding
   function Get_Port_Out (This : MinFr_Component) return Ptr_MinFr_OutPut_Port is abstract;
   not overriding
   procedure Add_Port (This : in out MinFr_Component; Port : Ptr_MinFr_Port) is abstract;
   not overriding
   procedure Add_Region (This : in out MinFr_Component; Region :  Ptr_Hierarchical_State) is abstract;
   not overriding
   function Get_Region (This : MinFr_Component;Id : State_Id) return Ptr_Hierarchical_State is abstract;--Id ha de ser un State_Id??????
   not overriding
   function Get_Unique_Id (This : MinFr_Component) return State_Id is abstract;--return ha de ser un State_Id??????
   not overriding
   function Get_Component_Data (This : MinFr_Component) return Ptr_MinFr_Component_Data is abstract;


end minfr.MinFr_Component;
