with Ada.Strings.Unbounded,
     Minfr.Msg.Minfr_Msg;

use Ada.Strings.Unbounded,
    Minfr.Msg.Minfr_Msg;

package minfr.MinFr_Component_Data is

   type MinFr_Component_Data is interface;
   type Ptr_MinFr_Component_Data is access all MinFr_Component_Data'Class;


   not overriding
   function Pop_OutPort_Msg (This : MinFr_Component_Data;Name: String) return Minfr_Msg is abstract;
   not overriding
   procedure Push_OutPort_Msg (This : MinFr_Component_Data;Name: String;Msg :Ptr_Minfr_Msg) is abstract;
   not overriding
   function Has_OutPort_Msg (This : in MinFr_Component_Data;Name : String) return Boolean is abstract;
   not overriding
   procedure Create_OutPort_Buffer (This : in out MinFr_Component_Data;Name : String;Bool : in out Boolean) is abstract;
   not overriding
   procedure Subscribe_To_InPort_Msg (This : in out MinFr_Component_Data;Name : String;Id : in out LastTable_Id) is abstract;
   not overriding
   procedure Push_In_Port_Msg (This : MinFr_Component_Data;Name: String;Msg :Ptr_Minfr_Msg) is abstract;
   not overriding
   function Pop_InPort_Msg (This : MinFr_Component_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is abstract;
   not overriding
   function Has_InPort_Msg (This : in MinFr_Component_Data;Name : String;Subs_Id : LastTable_Id) return Boolean is abstract;
   not overriding
   function Pop_UntilLast_InPort_Msg (This : MinFr_Component_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is abstract;
   not overriding
   procedure Subscribe_To_Event_Msg (this : in out MinFr_Component_Data; Name : String; Id : in out LastTable_Id) is abstract;
   not overriding
   procedure Push_Event_Msg (This : MinFr_Component_Data;Name: String;Msg :Ptr_Minfr_Msg) is abstract;
   not overriding
   function Pop_Event_Msg (This : MinFr_Component_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is abstract;
   not overriding
   function Has_Event_Msg (This : in MinFr_Component_Data;Name : String;Subs_Id : LastTable_Id) return Boolean is abstract;
   not overriding
   function Pop_UntilLast_Event_Msg (This : MinFr_Component_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is abstract;
   not overriding
   function Get_Complete_Name (this : in MinFr_Component_Data;Name : in string; Type_Msg : Msg_Type;Subs_Id : LastTable_Id) return String is abstract;
   not overriding
   function Get_Partial_Name (this : in MinFr_Component_Data;Name : in string; Type_Msg : Msg_Type) return string is abstract;


end minfr.MinFr_Component_Data;
