with minfr.Debug,
     Ada.Unchecked_Deallocation,
     Ada.Exceptions;

use minfr.Debug,
    Ada.Exceptions;

package body minfr.MinFr_Component_Data.MinFr_Data is


--------Publica-------------------------------
   function Constr_MinFr_Data (name : in string) return P_MinFr_Data is
   begin
      return tmp : P_MinFr_Data do --Indicamos que es un putero de Minfr_Msg
         tmp:=new MinFr_Data;  --Indicamos a la direcion que apunta
         tmp.My_Data := to_unbounded_string(name);
         --Msg := Constr_Minfr_Msg("msg").all;
      end return;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Constr_MinFr_Data--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return new MinFr_Data;
   end Constr_MinFr_Data;

   function Get_Name (this : in MinFr_Data) return string is
   begin
      return to_string(this.My_Data);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Get_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return to_string(this.My_Data);
   end Get_Name;


   function Get_Partial_Name (this : in MinFr_Data;Name : in string; Type_Msg : Msg_Type) return string is
      str : String := Name & "*" & Msg_Type'Image(Type_Msg);
   begin
      return str;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Get_Partial_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return str;
   end Get_Partial_Name;

   function Get_Complete_Name (this : in MinFr_Data;Name : in string; Type_Msg : Msg_Type;Subs_Id : LastTable_Id) return string is
      str : String := Name & "*" & Msg_Type'Image(Type_Msg)& LastTable_Id'Image(Subs_Id);
   begin
      return str;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Get_Complete_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return str;
   end  Get_Complete_Name;

----------------------------------------minfr_State---------------------------------------------

   procedure Register_State (this : in out MinFr_Data; State : Minfr_State_Ptr) is
      CA : StateTable.Cursor;
      Tmp_Bool : boolean;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name &"--Register_State--State.Get_Id : "& State_Id'Image(State.Get_Id)&" State.Get_Name : " & State.Get_Name);
      Pulse_key(Debug);
      this.State_Table.Insert(State.Get_Id,State,CA,Tmp_Bool);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Register_State--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Register_State;

   function get_State (this : in MinFr_Data; St_Id : Type_MD_State_Id) return Minfr_State_Ptr is
      CA : StateTable.Cursor;
      Tem_State : Minfr_State_Ptr;
   begin

      CA := this.State_Table.Find(State_Id(St_id));
      if  CA /= StateTable.No_Element then
         --return Element(CA);
         Tem_State := Element(CA);
      end if;
      return Tem_State;
   exception
      when Error: others =>
         print(true,"MinFr_Data--get_State--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return Tem_State;

   end get_State;

   procedure Print_State (this : in MinFr_Data) is
      iter : StateTable.Cursor;
      debug : boolean := false;
   begin
      print(debug,"Print_State");
      Pulse_key(Debug);
      iter := this.State_Table.First;
      if iter /= StateTable.No_Element then
         Bucle:
         loop
            print(debug,this.Get_Name &" Id_State : "& State_Id'Image(Element(iter).Get_Id) &"Name_State: " & Element(iter).Get_Name);
            Pulse_key(Debug);
            next(iter);
            exit Bucle when iter = StateTable.No_Element;
         end loop Bucle;
      end if;

   exception
      when Error: others =>
         print(true,"MinFr_Data--Print_State--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Print_State;



   ----------------------------------------OutPort_Msg---------------------------------------------


   function Pop_OutPort_Msg (This :MinFr_Data;Name: String) return Minfr_Msg is
      PartialName :string := This.Get_Partial_Name(Name,OutPort);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Msg1 : Minfr_Msg;
      --Tmp_Minfr_Msg : Ptr_Minfr_Msg;
      --procedure Liberar_Memoria is new Ada.Unchecked_Deallocation (Minfr_Msg, Ptr_Minfr_Msg);
      debug : boolean := false;

   begin
      print(Debug,"MinFr_Data--Pop_OutPort_Msg--Name : " & Name);
      Pulse_key(debug);
      CA :=This.Queue_Table.Find(partialName);
      if  CA /= QueueTable.No_Element then
         Tmp_P_MsgQueue := Element(CA);
         if Tmp_P_MsgQueue.Is_Empty then
            Msg1.Set_Error_Code(KO);
         else
            Msg1 := Tmp_P_MsgQueue.Last_Element;
            --Tmp_Minfr_Msg := Tmp_P_MsgQueue.Last_Element;
            Tmp_P_MsgQueue.Delete_Last;
            --Liberar_Memoria (Tmp_Minfr_Msg);
         end if;
      end if;
      print(Debug,"MinFr_Data--Pop_OutPort_Msg--return :MsgName: " & Msg1.Get_Name & "MsgValue: "& Msg1.get_Value("Dato"));
      Pulse_key(debug);
      return Msg1;

   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_OutPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return Msg1;
   end Pop_OutPort_Msg;

   procedure Push_OutPort_Msg (This : MinFr_Data;Name: String;Msg :Ptr_Minfr_Msg) is
      PartialName :string := This.Get_Partial_Name(Name,OutPort);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Msg_Push_OutPort : Minfr_Msg;
      debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--Push_OutPort_Msg--return :MsgName: " & Msg.Get_Name & "MsgValue: "& Msg.get_Value("Dato"));
      Pulse_key(debug);

      CA :=This.Queue_Table.Find(partialName);
      if  CA /= QueueTable.No_Element then
         --Msg_Push_OutPort := Constr_Minfr_Msg;
         Msg_Push_OutPort := Msg.all;
         Tmp_P_MsgQueue := Element(CA);
         Tmp_P_MsgQueue.Append(Msg_Push_OutPort);
         --Tmp_P_MsgQueue.Append(Msg);
         --print(true,"MinFr_Data--Push_OutPort_Msg--Tmp_P_MsgQueue.Append(Msg)");
      end if;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Push_OutPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);

   end Push_OutPort_Msg;

   function Has_OutPort_Msg (This : in MinFr_Data;Name : String) return Boolean is
      PartialName :string := This.Get_Partial_Name(Name,OutPort);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Bool:Boolean:=False;
      debug : boolean := false;
   begin

      print(Debug,"MinFr_Data--Has_OutPort_Msg--Name : " & Name);
      Pulse_key(debug);
      CA :=This.Queue_Table.Find(partialName);
      if  CA /= QueueTable.No_Element then
         Tmp_P_MsgQueue := Element(CA);
         if not(Tmp_P_MsgQueue.Is_Empty) then
            Bool := True;
         end if;
      end if;
      print(Debug,"MinFr_Data--Has_OutPort_Msg--return : " &boolean'Image(Bool));
      Pulse_key(debug);
      return Bool;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Has_OutPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return False;
   end Has_OutPort_Msg;

   procedure Create_OutPort_Buffer (This : in out MinFr_Data;Name : String;Bool : in out Boolean) is
      PartialName :string := This.Get_Partial_Name(Name,OutPort);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
   begin
      Tmp_P_MsgQueue := new MsgQueue.List;
      This.Queue_Table.Insert(PartialName,Tmp_P_MsgQueue,CA,Bool);

   exception
      when Error: others =>
         print(true,"MinFr_Data--Create_OutPort_Buffer--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Create_OutPort_Buffer;

----------------------------------------Inport_Msg---------------------------------------------

   procedure Subscribe_To_InPort_Msg (This : in out MinFr_Data;Name: String;Id : in out LastTable_Id) is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Subscribe_To_InPort_Msg--Name : " & Name & " Id : " & LastTable_Id'Image(Id));
      Pulse_key(Debug);
      This.Subscribe_To_Minfr_Msg(Name,InPort,Id);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Subscribe_To_InPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Subscribe_To_InPort_Msg;

   procedure Push_In_Port_Msg (This : MinFr_Data;Name: String;Msg :Ptr_Minfr_Msg) is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_In_Port_Msg--Name : " & Name & " Msg : " & Msg.Get_Name);
      Pulse_key(Debug);
      This.Push_Minfr_Msg(Name,Msg,InPort);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Push_In_Port_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Push_In_Port_Msg;

   function Pop_InPort_Msg (This : MinFr_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Pop_InPort_Msg--Name : " & Name & " Subs_Id : " & LastTable_Id'Image(Subs_Id));
      Pulse_key(Debug);
      return This.Pop_Minfr_Msg (Name,Subs_Id,InPort);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_InPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return This.Pop_Minfr_Msg (Name,Subs_Id,InPort);
   end Pop_InPort_Msg;

   function Has_InPort_Msg (This : in MinFr_Data;Name : String;Subs_Id : LastTable_Id) return Boolean is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_InPort_Msg : " & Name & " Subs_Id : " & LastTable_Id'Image(Subs_Id) & "return: " & boolean'Image(This.Has_Minfr_Msg(Name,Subs_Id,InPort)));
      Pulse_key(Debug);
      return This.Has_Minfr_Msg(Name,Subs_Id,InPort);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Has_InPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return This.Has_Minfr_Msg(Name,Subs_Id,InPort);
   end  Has_InPort_Msg;

   function Pop_UntilLast_InPort_Msg (This :MinFr_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is
   begin
      return this.Pop_Until_Last (Name,Subs_Id,InPort);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_UntilLast_InPort_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.Pop_Until_Last (Name,Subs_Id,InPort);
   end Pop_UntilLast_InPort_Msg;

----------------------------------------Event_Msg-----------------------------------------------

   procedure Subscribe_To_Event_Msg (this : in out MinFr_Data; Name : String; Id : in out LastTable_Id) is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Subscribe_To_Event_Msg--Name : " & Name & "Id : " & LastTable_Id'Image(Id));
      Pulse_key(Debug);
      This.Subscribe_To_Minfr_Msg(Name,Event,Id);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Subscribe_To_Event_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Subscribe_To_Event_Msg;

   procedure Push_Event_Msg (This : MinFr_Data;Name: String;Msg :Ptr_Minfr_Msg) is
      Debug : boolean := false;
   begin
      print(debug,"MinFr_Data--"& this.Get_Name & "--Push_Event_Msg--Name : " & Name);
      Pulse_key(Debug);
      this.Push_Minfr_Msg(Name,Msg,Event);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Push_Event_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Push_Event_Msg;


   function Pop_Event_Msg (This : MinFr_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Pop_Event_Msg--Name : " & Name & "Subs_Id : " & LastTable_Id'Image(Subs_Id));
      Pulse_key(Debug);
      return This.Pop_Minfr_Msg (Name,Subs_Id,Event);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_Event_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return This.Pop_Minfr_Msg (Name,Subs_Id,Event);
   end Pop_Event_Msg;


   function Has_Event_Msg (This : in MinFr_Data;Name : String;Subs_Id : LastTable_Id) return Boolean is
      Debug : boolean := false;
   begin
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Event_Msg--Name : " & Name & "Subs_Id : " & LastTable_Id'Image(Subs_Id));
      Pulse_key(Debug);
      return This.Has_Minfr_Msg(Name,Subs_Id,Event);

   exception
      when Error: others =>
         print(true,"MinFr_Data--Has_Event_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return This.Has_Minfr_Msg(Name,Subs_Id,Event);
   end Has_Event_Msg;

   function Pop_UntilLast_Event_Msg (This : MinFr_Data;Name: String;Subs_Id : LastTable_Id) return Minfr_Msg is
   begin
      print(debug,"MinFr_Data--Pop_UntilLast_Event_Msg--this.Pop_Until_Last (" & Name &","& LastTable_Id'Image(Subs_Id) & "," & msg_Type'Image(Event) & ")");
      return this.Pop_Until_Last (Name,Subs_Id,Event);
   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_UntilLast_Event_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.Pop_Until_Last (Name,Subs_Id,Event);
   end Pop_UntilLast_Event_Msg;


-----------------------------------------Privada----------------------------------
   procedure Subscribe_To_Minfr_Msg (This : in out MinFr_Data;Name : String; Type_Msg  :Msg_Type;Id : in out LastTable_Id) is

      PartialName :string := This.Get_Partial_Name(Name,Type_Msg);
      CompleteName :Unbounded_String;
      A : LastIdTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Tmp_Bool : Boolean;
      Debug : boolean := false;

   begin

      print(debug,"MinFr_Data--Subscribe_To_Minfr_Msg--this.Last_Queue_Subs_Id.Insert(Key_Type-->"& PartialName &", Element_Type-->0");
      Pulse_key(Debug);
      This.Last_Queue_Subs_Id.Insert(PartialName,0,A,Tmp_Bool);
      print(debug,"MinFr_Data--Subscribe_To_Minfr_Msg--Tmp_Bool : " & boolean'Image(Tmp_Bool));
      Pulse_key(Debug);
      CompleteName := to_unbounded_string(This.Get_Complete_Name(Name,Type_Msg, Element(A)));
     -- Put_Line("Subscribe_To_Minfr_Msg.CompleteName:"&To_String(CompleteName));
     -- Get(Aux);
      Tmp_P_MsgQueue := new MsgQueue.List;
      print(debug,"MinFr_Data--Subscribe_To_Minfr_Msg--This.Queue_Table.Insert(Key_Type-->"& To_String(CompleteName) &", Element_Type-->Tmp_P_MsgQueue");
      Pulse_key(Debug);
      This.Queue_Table.Insert(To_String(CompleteName),Tmp_P_MsgQueue);
      Id :=  Element(A);
      print(debug,"MinFr_Data--Subscribe_To_Minfr_Msg--Id=" & LastTable_Id'Image(Id));
      Pulse_key(Debug);
      This.Last_Queue_Subs_Id.Replace_Element(A, Element(A)+1);
      --delay 20.0;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Subscribe_To_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);

   end Subscribe_To_Minfr_Msg;


   procedure Push_Minfr_Msg (This : MinFr_Data; Name :String; Msg : Ptr_Minfr_Msg; Type_Msg :Msg_Type) is

      PartialName :string := This.Get_Partial_Name(Name,Type_Msg);
      CompleteName :Unbounded_String;
      A : LastIdTable.Cursor;
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Debug : boolean := false;
      Msg_Push_Minfr : Minfr_Msg;

   begin
--        if (Type_Msg = InPort) then
--           Debug := True;
--        end if;

      print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_Minfr_Msg--Name : " & Name & " Msg : " & Msg.Get_Name & " Type_Msg : " & Msg_Type'Image(Type_Msg));
      Pulse_key(Debug);
      print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_Minfr_Msg--partialName : " & partialName);
      Pulse_key(Debug);
      A :=This.Last_Queue_Subs_Id.Find(partialName);
      if A /= LastIdTable.No_Element then
         print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_Minfr_Msg--Hay Tabla Last_Queue_Subs_Id--partialName : " & partialName);
         Pulse_key(Debug);
         for I in 0..Element(A) loop
            CompleteName := to_unbounded_string(This.Get_Complete_Name(Name,Type_Msg,LastTable_Id(I)));
            print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_Minfr_Msg--CompleteName : "& to_string(CompleteName));
            Pulse_key(Debug);
            CA :=This.Queue_Table.Find(to_string(CompleteName));
            if  CA /= QueueTable.No_Element then
               print(Debug,"MinFr_Data--"& this.Get_Name & "--Push_Minfr_Msg--Append--Msg : "& Msg.Get_Name);
               Pulse_key(Debug);
               --Msg_Push_Minfr := Constr_Minfr_Msg;
               Msg_Push_Minfr := Msg.all;
               Tmp_P_MsgQueue := Element(CA);
               Tmp_P_MsgQueue.Append(Msg_Push_Minfr);
            end if;
         end loop;
      end if;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Push_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Push_Minfr_Msg;

   function Pop_Minfr_Msg (This : MinFr_Data;Name :String;SubsId : LastTable_Id;Type_Msg :Msg_Type) return Minfr_Msg is
      CompleteName :String := This.Get_Complete_Name(Name,Type_Msg,SubsId);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      --Tmp_Minfr_Msg : Ptr_Minfr_Msg;
      Msg2 : Minfr_Msg;
      --procedure Liberar_Memoria is new Ada.Unchecked_Deallocation (Minfr_Msg, Ptr_Minfr_Msg);
   begin
      print(Debug,"MinFr_Data--Pop_Minfr_Msg--");
      Pulse_key(Debug);
      --Put_Line("Pop_Minfr_Msg.CompleteName:"&CompleteName);
      --Get(Aux);

      CA :=This.Queue_Table.Find(CompleteName);
      if  CA /= QueueTable.No_Element then

         --Put_Line("Pop_Minfr_Msg.hay elemento Queue_Table");
         --Get(Aux);


         print(Debug,"MinFr_Data--Pop_Minfr_Msg--QueueTable.Length" & Count_Type'Image(QueueTable.Element(CA).Length));
         Pulse_key(Debug);
         Tmp_P_MsgQueue := Element(CA);
         print(Debug,"MinFr_Data--Pop_Minfr_Msg--Tmp_P_MsgQueue.Length" & Count_Type'Image(Tmp_P_MsgQueue.Length));
         Pulse_key(Debug);
         if Tmp_P_MsgQueue.Is_Empty then
            Msg2.Set_Error_Code(KO);
            print(Debug,"MinFr_Data--Pop_Minfr_Msg--MsgQueue vacia--Msg.Set_Error_Code(KO)");
            Pulse_key(Debug);
            --Put_Line("Pop_Minfr_Msg.MsgQueue vacia");
            --Get(Aux);

         else
            --Put_Line("Pop_Minfr_Msg.MsgQueue tiene elemento");
            --Get(Aux);
            --Esto hay que quitarlo ????
            print(Debug,"MinFr_Data--Pop_Minfr_Msg--MsgQueue tiene elemento");
            Pulse_key(Debug);
            Msg2 := Tmp_P_MsgQueue.Last_Element;
            --Tmp_Minfr_Msg.all := Tmp_P_MsgQueue.Last_Element;
            Tmp_P_MsgQueue.Delete_Last;
            --Liberar_Memoria(Tmp_Minfr_Msg);
            print(Debug,"MinFr_Data--Pop_Minfr_Msg--Msg" & Msg2.Get_Name);
            Pulse_key(Debug);
         end if;
      else
         Msg2.Set_Error_Code(KO);
         print(Debug,"MinFr_Data--Pop_Minfr_Msg--Queue_Table vacia--Msg.Set_Error_Code(KO)");
         Pulse_key(Debug);
        -- Put_Line("Pop_Minfr_Msg.no hay elemento Queue_Table");
         --Get(Aux);
      end if;

      return Msg2;
   exception
      when Error: others =>
         print(true,"MinFr_Data--Pop_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return Msg2;


   end Pop_Minfr_Msg;

   function Has_Minfr_Msg(This : MinFr_Data; Name :String; SubsId : LastTable_Id; Type_Msg :Msg_Type) return Boolean is

      CompleteName :String := This.Get_Complete_Name(Name,Type_Msg,SubsId);
      CA : QueueTable.Cursor;
      Tmp_P_MsgQueue : P_MsgQueue;
      Tmp_Bool : Boolean := False;
      Debug : Boolean := false;

   begin

--        if (Type_Msg = InPort) then
--           Debug := True;
--        end if;

      print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Minfr_Msg--Name: " & Name & " Subs_Id : " & LastTable_Id'Image(SubsId) & " Type_Msg : " & Msg_Type'Image(Type_Msg));
      Pulse_key(Debug);

       print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Minfr_Msg--CompleteName : " & CompleteName);
        Pulse_key(Debug);

      CA :=This.Queue_Table.Find(CompleteName);
      if  CA /= QueueTable.No_Element then

         print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Minfr_Msg--Hay Tabla QueueTable CompleteName : " & CompleteName);
         Pulse_key(Debug);

         Tmp_P_MsgQueue := Element(CA);

         print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Minfr_Msg--Length.Tmp_P_MsgQueue : " & Count_Type'Image(Tmp_P_MsgQueue.Length));
         Pulse_key(Debug);

         if not(Tmp_P_MsgQueue.Is_Empty) then
            Tmp_Bool := True;
         end if;
      else
         print(Debug,"MinFr_Data--"& this.Get_Name & "--Has_Minfr_Msg--No Existe CompleteName : " & CompleteName);
         Pulse_key(Debug);
      end if;
      return Tmp_Bool;

   exception
      when Error: others =>
         print(true,"MinFr_Data--Has_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return Tmp_Bool;

   end Has_Minfr_Msg;

   function Pop_Until_Last (This : MinFr_Data; Name :String; SubsId : LastTable_Id; Type_Msg :Msg_Type) return Minfr_Msg is
      --Msg_C : Ptr_Minfr_Msg := Constr_Minfr_Msg("msgL");
      --Msg_L : Ptr_Minfr_Msg := Constr_Minfr_Msg("msgD");
      flag : boolean := true;
      Error : Port_Erro_Code;
      Msg_C : Minfr_Msg;
      Msg_L : Minfr_Msg;

   begin
      Msg_C.Set_Error_Code(OK);
      Msg_L.Set_Error_Code(OK);
      Error := Msg_C.Get_Error_Code;
      print(Debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--Msg_C.Get_Error_Code :=" & Port_Erro_Code'Image(Error));
      Pulse_key(Debug);
      while (Error = OK) loop
         print(Debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--Bucle While");
         if flag then
            print(Debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--Msg_C.Set_Error_Code(KO)");
            Msg_C.Set_Error_Code(KO);
            flag := false;
         end if;
         Msg_L := Msg_C;
         print(Debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--this.Pop_Minfr_Msg("& Name & "," & LastTable_Id'Image(SubsId) & "," & Msg_Type'Image(Type_Msg) & ")");
         Msg_C := this.Pop_Minfr_Msg(Name,SubsId,Type_Msg);
         Error := Msg_C.Get_Error_Code;
         print(Debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--Msg_C.Get_Error_Code :=" & Port_Erro_Code'Image(Error));
         Pulse_key(Debug);
      end loop;
      print(debug,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--return");
      --Liberar_Memoria(Msg_C);
      return Msg_L;

   exception
      when Error: others =>
         print(true,"MinFr_Data--" & This.Get_Name & "--Pop_Until_Last--exception: " & Exception_Information(Error));
         Pulse_key(true);
         return Msg_L;

   end Pop_Until_Last;





end minfr.MinFr_Component_Data.MinFr_Data;
