with minfr.Debug;
use minfr.Debug;

package body minfr.MinFr_Port is
   ------------------MinFr_Port--------------------------------------

   function Get_Unique_Id (this:in MinFr_Port) return Port_ID is
   begin
      return Tmp :Port_ID do
         Tmp := This.Unique_Port_ID;
      end return;
   end  Get_Unique_Id;

   procedure Set_Conjugate (this:in out  MinFr_Port'Class;P_Port : Ptr_MinFr_Port) is
      --Aux : Ptr_MinFr_Port;
      AuxIn :Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port;
      AuxOut :Ptr_MinFr_Output_Port := Constr_MinFr_Output_Port;
   begin
     --aux := this'Access;

      if ((P_Port'Tag = Ptr_MinFr_Port(AuxIn)'Tag) and (this'tag = Ptr_MinFr_Port(AuxIn)'Tag)) or
      ((P_Port'Tag = Ptr_MinFr_Port(AuxOut)'Tag) and (this'Tag = Ptr_MinFr_Port(AuxOut)'Tag)) then

         raise Ports_Same_Type;

      end if;


     -- if ((P_Port'Tag = Ptr_MinFr_Port(AuxIn)'Tag) and (this'Tag = Ptr_MinFr_Port(AuxIn)'Tag)) or
     --   ((P_Port'Tag = Ptr_MinFr_Port(AuxOut)'Tag) and (this'Tag = Ptr_MinFr_Port(AuxOut)'Tag)) then
     --    raise Ports_Same_Type;
      --end if;




      ---asegurar que la conesion entre puetos son se distinto puertos entrada con salida o al contrario
      --if (This in P_Port.all'Tag) then raise Ports_Same_Type; end if;
      -- if (P_Port'Tag = This.all'Tag)then raise Ports_Same_Type; end if;

      if (This.Conjugate /= P_Port) then
         This.Conjugate := P_Port;
           --new MinFr_Port'(P_Port.all);
           --(P_Port.all);
      else raise Port_Self_Connect; --Se esta conectando a si mismo
      end if;


   end Set_Conjugate;

   function Get_Conjugate (this:in MinFr_Port'Class) return Ptr_MinFr_Port is
   begin
      return This.Conjugate;
   end Get_Conjugate;

   function Is_Connected (this:in MinFr_Port) return Boolean is
   begin
      return Tmp :Boolean do
         Tmp := false;
         if (This.Conjugate /= null) then
            Tmp := True;
           end if;
      end return;
   end Is_Connected;

   procedure Disconnect (this:in out MinFr_Port) is
   begin
      This.Conjugate := null;
   end Disconnect;

   function Get_Name (this:in MinFr_Port) return String is
   begin
      return to_string(This.Name);
   end Get_Name;


   ------------------MinFr_Input_Port-------------------------------

   function Constr_MinFr_Input_Port (Id :Port_ID;
                                     Unique_Component_Id :Component_Id; Name :String;
                                     Comp_Data : P_MinFr_Data)
                                     return Ptr_MinFr_Input_Port is
   begin

      return Tmp : Ptr_MinFr_Input_Port do
         Tmp := new MinFr_Input_Port;
         Tmp.Unique_Port_ID := Id+Port_ID(Unique_Component_Id)*1000;
         Tmp.Conjugate := null;
         Tmp.Name := to_unbounded_string(Name);
         --Tmp.Comp_Data := Constr_MinFr_Data;
         Tmp.Comp_Data := Comp_Data;
      end return;
   end Constr_MinFr_Input_Port;

   function Constr_MinFr_Input_Port return Ptr_MinFr_Input_Port is
   begin
      return Tmp : Ptr_MinFr_Input_Port do
         Tmp := new MinFr_Input_Port;
      end return;
   end Constr_MinFr_Input_Port;

   procedure UpDate (this:in out  MinFr_Input_Port;D_Minfr_Msg :in Ptr_Minfr_Msg) is
      Name : string := To_String(This.Name);
      Debug : Boolean := false;
   begin
      print(debug,"MinFr_Input_Port--UpDate--Port_Name : " & this.Get_Name & " Set-MSG : " & D_Minfr_Msg.Get_Name);
      Pulse_key(debug);
      D_Minfr_Msg.Set_Destination_Id(O_Port_Id(This.Unique_Port_ID));
      This.Comp_Data.Push_In_Port_Msg(Name,D_Minfr_Msg);
   end UpDate;


    ------------------MinFr_OutPut_Port-------------------------------
   function Constr_MinFr_OutPut_Port (Id :Port_ID;
                                      Unique_Component_Id :Component_Id; Name :String)
                                      return  Ptr_MinFr_OutPut_Port is
   begin
      return Tmp : Ptr_MinFr_OutPut_Port do
         Tmp:= new MinFr_OutPut_Port;
         Tmp.Unique_Port_ID := Id+Port_ID(Unique_Component_Id)*1000;
         Tmp.Conjugate := null;
         Tmp.Name := to_unbounded_string(Name);
      end return;
   end Constr_MinFr_OutPut_Port;

   function Constr_MinFr_OutPut_Port return  Ptr_MinFr_OutPut_Port is
   begin
      return Tmp : Ptr_MinFr_OutPut_Port do
         Tmp:= new MinFr_OutPut_Port;
      end return;
   end Constr_MinFr_OutPut_Port;


   procedure UpDate (this:in out  MinFr_OutPut_Port;D_Minfr_Msg :in Ptr_Minfr_Msg) is
      Debug : Boolean := false;
   begin
      print(debug,"MinFr_OutPut_Port--UpDate--Port_Name : " & this.Get_Name & " Set-MSG : " & D_Minfr_Msg.Get_Name);
      Pulse_key(debug);
      D_Minfr_Msg.Set_Origin_Id(O_Port_ID(this.Unique_Port_ID));
      if (This.Conjugate /= null) then
         This.Conjugate.UpDate(D_Minfr_Msg);
      end if;
   end UpDate;




end minfr.MinFr_Port;
