with Ada.Strings.Unbounded,
     Minfr.Msg.Minfr_Msg,
     Minfr.Msg_Aux,
     Minfr.MinFr_Component_Data.MinFr_Data,
     Ada.Tags;

use Ada.Strings.Unbounded,
    Minfr.Msg.Minfr_Msg,
    Minfr.Msg_Aux,
    Minfr.MinFr_Component_Data.MinFr_Data,
    Ada.Tags;



package minfr.MinFr_Port is

   type Port_ID is new Positive;
   type Component_ID is new Positive;

   type Type_MinFr_Port is (P_In,P_Out);

   type MinFr_Port is abstract tagged private;
   type Ptr_MinFr_Port is access all Minfr_Port'Class;





------------------MinFr_Port--------------------------------------
   not overriding
   function Get_Unique_Id (this:in MinFr_Port) return Port_ID;
   not overriding
   procedure UpDate (this:in out MinFr_Port;D_Minfr_Msg :in Ptr_Minfr_Msg) is abstract;  --C++ la iguala a 0 para indicar que es abstract
   not overriding
   procedure Set_Conjugate (this:in out MinFr_Port'Class;P_Port : Ptr_MinFr_Port);
   not overriding
   function Get_Conjugate (this:in MinFr_Port'Class) return Ptr_MinFr_Port;
   not overriding
   function Is_Connected (this:in MinFr_Port) return Boolean;
   not overriding
   procedure Disconnect (this:in out MinFr_Port);
   not overriding
   function Get_Name (this:in MinFr_Port) return String;



   ------------------MinFr_Input_Port-------------------------------
   type MinFr_Input_Port (<>) is new MinFr_Port with private;
   type Ptr_MinFr_Input_Port is access all MinFr_Input_Port;
   not overriding
   function Constr_MinFr_Input_Port (Id :Port_ID;Unique_Component_Id :Component_Id; Name :String;Comp_Data : P_MinFr_Data) return Ptr_MinFr_Input_Port;
   not overriding
   function Constr_MinFr_Input_Port return Ptr_MinFr_Input_Port;
   overriding
   procedure UpDate (this:in out  MinFr_Input_Port; D_Minfr_Msg :in Ptr_Minfr_Msg);



   ------------------MinFr_Output_Port-------------------------------
   type MinFr_OutPut_Port (<>) is new MinFr_Port with private;
   type Ptr_MinFr_OutPut_Port is access all MinFr_OutPut_Port;
   not overriding
   function Constr_MinFr_OutPut_Port (Id :Port_ID;Unique_Component_Id :Component_Id; Name :String) return Ptr_MinFr_OutPut_Port;
   not overriding
   function Constr_MinFr_OutPut_Port return Ptr_MinFr_OutPut_Port;
   overriding
   procedure UpDate (this:in out  MinFr_OutPut_Port;D_Minfr_Msg :in Ptr_Minfr_Msg);




  Port_Self_Connect, Ports_Same_Type : exception;








private

   Debug : Boolean := False;

   type MinFr_Port  is abstract tagged record
      Unique_Port_ID : Port_Id;
      Unique_Component_Id : Component_Id;
      Conjugate : Ptr_MinFr_Port;
      Name : Unbounded_String;
      --pragma Atomic (Unique_Port_Id);
     pragma Atomic (Conjugate);
   end record;


   type  MinFr_Input_Port is new MinFr_Port with record
      Comp_Data : P_MinFr_Data;
   end record;

   type  MinFr_OutPut_Port is new MinFr_Port with null record;

end minfr.MinFr_Port;
