with minfr.Debug,
     Ada.Exceptions;

use minfr.Debug,
    Ada.Exceptions;

package body minfr.Minfr_State.Hierarchical_State is

   --***************************************************************
   --**********************Hierarchical_State***********************
   --***************************************************************

   -----------------------------Constructo------------------------

--     function Constr_Hierarchical_State (data : P_MinFr_Data;Id :State_Id) return Ptr_Hierarchical_State is
--     begin
--        return tmp :Ptr_Hierarchical_State do --Indicamos que es un putero de Hierarchical_State
--           tmp:=new Hierarchical_State;  --Indicamos a la direcion que apunta
--           Constr_Minfr_State (Minfr_State_Ptr(tmp),Id);
--           tmp.Current_St := 0;
--           tmp.Next_St := 0;
--           tmp.My_Activity := Ptr_State_Activity(Cont_Hierarchical_Activity(tmp));
--           tmp.My_Activity.Set_Id(Id_State_Activity(Id));
--           tmp.My_Component_Data := data;
--        end return;
--     end Constr_Hierarchical_State;

   procedure Constr_Hierarchical_State ( tmp :in out Ptr_Hierarchical_State; data : P_MinFr_Data;Id :State_Id) is
   begin
         --tmp:=new Hierarchical_State;  --Indicamos a la direcion que apunta
      Constr_Minfr_State (Minfr_State_Ptr(tmp),Id);
      tmp.Current_St := 0;
      tmp.Next_St := 0;
      tmp.My_Activity := Ptr_State_Activity(Cont_Hierarchical_Activity(tmp));
      tmp.My_Activity.Set_Id(Id_State_Activity(Id));
      tmp.My_Component_Data := data;
      --tmp.ha := Cont_Hierarchical_Activity(tmp);
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Constr_Hierarchical_State--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Constr_Hierarchical_State;

   ----------------------------------------------------------------

   function Get_States (this : Hierarchical_State) return Vector is
   begin
      return this.My_States;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Get_States--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.My_States;
   end Get_States;


   procedure Set_Enable_State_Id (this : in Hierarchical_State;St_Id : in State_Id) is
   begin
      this.My_Activity.Set_Enable_State_Id(Id_State_Activity(St_Id));
   exception
     when Error: others =>
         print(true,"Hierarchical_Activity--Set_Enable_State_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Enable_State_Id;

   --------------------------Minfr_State--------------------------

   function Resolve_Next_State (This : Hierarchical_State) return State_Id is
   begin
      print(debug,"Hierarchical_State--Resolve_Next_State--" & this.My_Component_Data.get_State(Type_MD_State_Id(this.Current_St)).Get_Name & ".Resolve_Next_State");
      Pulse_key(debug);
      return this.My_Component_Data.get_State(Type_MD_State_Id(this.Current_St)).Resolve_Next_State;
   exception
     when Error: others =>
         print(true,"Hierarchical_Activity--Resolve_Next_State--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return 1;
   end Resolve_Next_State;

--     function Get_Hierarchical_Activity (This : Hierarchical_State) return Ptr_Hierarchical_Activity is
--     begin
--        return this.ha;
--     end Get_Hierarchical_Activity;

   --***************************************************************
   --**********************Hierarchical_Activity********************
   --***************************************************************

   -----------------------------Constructo------------------------

   function Cont_Hierarchical_Activity (hs :Ptr_Hierarchical_State) return Ptr_Hierarchical_Activity is
   begin
      return tmp :Ptr_Hierarchical_Activity do --Indicamos que es un putero de Hierarchical_State
         tmp:=new Hierarchical_Activity;  --Indicamos a la direcion que apunta
         tmp.T := 0;
         tmp.Over_Charge := 0;
         tmp.k := 0;
         tmp.My_Name := to_unbounded_string("ME_Hand");
         tmp.hs := hs;
         tmp.First_Exec := true;
         tmp.Cond_St_Active := null;
      end return;

   exception
     when Error: others =>
         print(true,"Hierarchical_Activity--Cont_Hierarchical_Activity--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return new Hierarchical_Activity;
   end Cont_Hierarchical_Activity;

   ----------------------------------------------------------------

   function Can_Execute(this : Hierarchical_Activity) return boolean is
      flag1 : boolean := false;
      flag2 : boolean := true;
      result : boolean := false;
      Actual_Time : Time;
      Elapsed_Time : Time_Span;
   begin
      print(debug,"Hierarchical_Activity--Can_Execute--Paso1");
      if (this.Cond_St_Active /= null) then
         print(debug,"Hierarchical_Activity--Can_Execute--Paso2");
         flag2 := this.Cond_St_Active.Evaluate_Condition;
      end if;
      print(debug,"Hierarchical_Activity--Can_Execute--Paso3");
      Actual_Time := Clock;
      Elapsed_Time := Actual_Time - this.lastExecTime;
      if Elapsed_Time > Milliseconds(integer(this.T)) then
         flag1 := true;
      end if;
      if this.First_Exec then
         flag1 := true;
      end if;
      if (flag1 and flag2) then
         result := true;
      end if;

      print(debug,"Hierarchical_Activity--Can_Execute--return--"& boolean'Image(result));


       --  print(true,"Hierarchical_Activity--Can_Execute--" & this.Get_Name & "--exception");

      return result;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Can_Execute--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return result;

   end Can_Execute;

   procedure Print_Region_State(this : Hierarchical_Activity) is
   begin
      this.hs.My_Component_Data.Print_State;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Print_Region_State--exception : " & Exception_Information(Error));
         Pulse_key(true);

   end Print_Region_State;

   ----------------------------Sobrecargable-----------------------

   procedure Set_Over_charge (This : in out Hierarchical_Activity; n : in Type_Sob_Charge)is
   begin
      this.Over_Charge := n;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Set_Over_charge--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Over_charge;

   -----------------------------State_Activity----------------------

   procedure Execute_Tick (this : in out Hierarchical_Activity)is
      debug : boolean := false;
   begin
      print(debug,"Hierarchical_Activity--Execute_Tick--Paso1");
      this.lastExecTime := Clock;
      print(debug,"Hierarchical_Activity--Execute_Tick--this.First_Exec = " & boolean'Image(this.First_Exec));
      Pulse_key(debug);
      if (this.First_Exec) then
         print(debug,"Hierarchical_Activity--Execute_Tick--" & this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).Get_Name & ".On_Entry");
         Pulse_key(debug);
         this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).On_Entry;
      end if;
      print(debug,"Hierarchical_Activity--Execute_Tick--Paso2");
      Pulse_key(debug);
      this.First_Exec := false;
      -- 1.- Execute activity tick.
      print(debug,"Hierarchical_Activity--Execute_Tick--" & this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).Get_Name & ".Execute_Tick");
      Pulse_key(debug);

      this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).Execute_Tick;

      -- 2.- Resolve next state.
      print(debug,this.Get_Name & "--Hierarchical_Activity--Execute_Tick--Resolve next state");
      Pulse_key(debug);
      this.hs.Next_St := this.hs.Resolve_Next_State;

      -- 3.- Execute exit and entry actions if proceeds.
      -- Context information if any should be saved on exit actions.
      --debug := True;
      print(debug,this.Get_Name & "--Hierarchical_Activity--Execute_Tick--this.hs.Next_St =" & State_Id'Image(this.hs.Next_St));
      Pulse_key(debug);


      if (this.hs.Next_St >= 0) then
         print(debug,"Hierarchical_Activity--Execute_Tick--this.hs.Next_St >= 0");
         print(debug,"Hierarchical_Activity--Execute_Tick--" & this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).Get_Name & ".On_Exit");
         Pulse_key(debug);
         this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).On_Exit;
         this.hs.Current_St := this.hs.Next_St;
         print(debug,"Hierarchical_Activity--Execute_Tick--" & this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).Get_Name & ".On_Entry");
         Pulse_key(debug);
         this.hs.My_Component_Data.get_State(Type_MD_State_Id(this.hs.Current_St)).On_Entry;
      end if;
      --debug := false;

   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Execute_Tick--" & this.Get_Name &"--exception : " & Exception_Information(Error));
         Pulse_key(true);

   end Execute_Tick;

   procedure Set_Period (this : in out Hierarchical_Activity;Per_ms : type_SA_Period)is
   begin
      this.T := Per_ms;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Set_Period--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Period;

   function Get_Period (this : Hierarchical_Activity) return type_SA_Period is
   begin
      return this.T;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Get_Period--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.T;
   end Get_Period;

   function Is_Done (this : Hierarchical_Activity) return boolean is
   begin
      return false;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity-Is_Done--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return false;
   end Is_Done;

   function Get_Name (this : Hierarchical_Activity) return string is
   begin
      return to_string(this.My_Name) & "_" & to_string(this.hs.Name);
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Get_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return "exception";
   end Get_Name;

   procedure Set_Name (this : in out Hierarchical_Activity; str :string) is
   begin
      this.My_Name := this.My_Name & to_unbounded_string(str);
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Set_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Name;

   procedure Set_Id (This : in out Hierarchical_Activity;id : Id_State_Activity) is
   begin
      this.id := id;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Set_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Id;

   function Get_Id (this : Hierarchical_Activity) return Id_State_Activity is
   begin
      return this.id;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Get_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.id;
   end Get_Id;

   procedure Execute_On_Entry (This :in out Hierarchical_Activity)is
   begin
      null;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Execute_On_Entry--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Execute_On_Entry;

   procedure Execute_On_Exit (This : Hierarchical_Activity)is
   begin
      null;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Execute_On_Exit--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Execute_On_Exit;

   procedure Set_Enable_State_Id (This : in out Hierarchical_Activity;St_Id : Id_State_Activity) is
   begin
      if This.Cond_St_Active = null then
         This.Cond_St_Active := Constr_Condition_State_Active(this.hs.My_Component_Data,Type_CstAc_Id(St_Id),true);
      end if;
   exception
      when Error: others =>
         print(true,"Hierarchical_Activity--Set_Enable_State_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Enable_State_Id;





end minfr.Minfr_State.Hierarchical_State;
