with minfr.MinFr_Component_Data.MinFr_Data,
     minfr.Sobrecargable,
     minfr.State_Activity,
     minfr.Condition.Condition_State_Active,
     Ada.Real_Time,
     ada.Containers.Vectors;

use minfr.MinFr_Component_Data.MinFr_Data,
    minfr.Sobrecargable,
    minfr.State_Activity,
    minfr.Condition.Condition_State_Active,
    Ada.Real_Time,
    ada.Containers;

package minfr.Minfr_State.Hierarchical_State is

   type Index_Vector is new Natural;
   package States_Container is new Ada.Containers.Vectors (Index_Vector, State_Id);
   use States_Container;
   --***************************************************************
   --**********************Hierarchical_State***********************
   --***************************************************************
   type Hierarchical_State is abstract new Minfr_State with private;
   type Ptr_Hierarchical_State is access all Hierarchical_State'Class;

    --***************************************************************
   --**********************Hierarchical_Activity********************
   --***************************************************************
   type Type_Ha_k is new Natural;
   type Hierarchical_Activity (<>) is new minfr.Sobrecargable.Sobrecargable and minfr.State_Activity.State_Activity with private;
   type Ptr_Hierarchical_Activity is access Hierarchical_Activity;

   --***************************************************************
   --**********************Hierarchical_State***********************
   --***************************************************************
   -----------------------------Constructo------------------------
   not overriding
   procedure Constr_Hierarchical_State ( tmp :in out Ptr_Hierarchical_State; data : P_MinFr_Data;Id :State_Id);
   ----------------------------------------------------------------
   not overriding
   function Get_States (this : Hierarchical_State) return States_Container.Vector;
   not overriding
   procedure Set_Enable_State_Id (this : in Hierarchical_State;St_Id : in State_Id);
--     not overriding
--     function Get_Hierarchical_Activity (This : Hierarchical_State) return Ptr_Hierarchical_Activity;
   --------------------------Minfr_State--------------------------
   --overriding
   --procedure On_Entry (This : in out Hierarchical_State);
   --overriding
   --procedure On_Exit (This : in out Hierarchical_State);
   overriding
   function Resolve_Next_State (This : Hierarchical_State) return State_Id;

   --***************************************************************
   --**********************Hierarchical_Activity********************
   --***************************************************************
   -----------------------------Constructo------------------------
   not overriding
   function Cont_Hierarchical_Activity (hs :Ptr_Hierarchical_State) return Ptr_Hierarchical_Activity;
   ----------------------------------------------------------------
   not overriding
   function Can_Execute(this : Hierarchical_Activity) return boolean;
   not overriding
   procedure Print_Region_State(this : Hierarchical_Activity);
   ----------------------------Sobrecargable-----------------------
   overriding
   procedure Set_Over_charge (This : in out Hierarchical_Activity; n : in Type_Sob_Charge);
   -----------------------------State_Activity----------------------
   overriding
   procedure Execute_Tick (this : in out Hierarchical_Activity);
   overriding
   procedure Set_Period(This : in out Hierarchical_Activity;Per_ms : type_SA_Period);
   overriding
   function Get_Period (this : Hierarchical_Activity) return type_SA_Period;
   overriding
   function Is_Done (this : Hierarchical_Activity) return boolean;
   overriding
   function Get_Name (this : Hierarchical_Activity) return string;
   overriding
   procedure Set_Name (this : in out Hierarchical_Activity; str :string);
   overriding
   procedure Set_Id (This : in out Hierarchical_Activity;id : Id_State_Activity);
   overriding
   function Get_Id (this : Hierarchical_Activity) return Id_State_Activity;
   overriding
   procedure Execute_On_Entry (This : in out Hierarchical_Activity);
   overriding
   procedure Execute_On_Exit (This : Hierarchical_Activity);
   overriding
   procedure Set_Enable_State_Id (This : in out Hierarchical_Activity;St_Id : Id_State_Activity);

private

   debug : boolean := false;

   type Hierarchical_State is abstract new Minfr_State with record
      My_Component_Data  : P_MinFr_Data;
      Current_St : State_Id;
      Next_St    : State_Id;
      My_States  : States_Container.Vector;
      --ha :  Ptr_Hierarchical_Activity;
   end record;

    type  Hierarchical_Activity is new  minfr.Sobrecargable.Sobrecargable and minfr.State_Activity.State_Activity with record
      lastExecTime : Time;
      hs : Ptr_Hierarchical_State;
      T : type_SA_Period;
      Over_Charge : Type_Sob_Charge;
      k : Type_Ha_k; -- volatile
      My_Name : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica
      id : Id_State_Activity;
      First_Exec : boolean;
      Cond_St_Active : Ptr_Condition_State_Active;
   end record;


end  minfr.Minfr_State.Hierarchical_State;
