with minfr.Debug;
use minfr.Debug;

package body minfr.Minfr_State.Leaf_State is

   ---------Constructores----------
   function Constr_Leaf_State (stID : State_Id; name : string) return Ptr_Leaf_State is
      tmp1 : Minfr_State_Ptr;
   begin
      return Tmp : Ptr_Leaf_State do
         Tmp := new Leaf_State;
         tmp1 := Minfr_State_Ptr(Tmp);
         --Constr_Minfr_State (Minfr_State_Ptr(tmp),stID);
         Constr_Minfr_State (tmp1,stID);
         Tmp.Name := to_unbounded_string(name);
      end return;
   end Constr_Leaf_State;

   ----------------------------------------------------------------
   procedure Add_Transition(This : in out Leaf_State; trans : Ptr_Transition) is
   begin
      print(debug,"Leaf_State-- Add_Transition--transitions.Length:" & Index_Vector'Image(Index_Vector(this.transitions.Length)));
      This.transitions.Append(trans);
      print(debug,"Leaf_State-- Add_Transition--transitions.Length:" & Index_Vector'Image(Index_Vector(this.transitions.Length)));
      --delay 10.0;
   end Add_Transition;

   procedure Set_Activity(This : in out Leaf_State; State_Act : Ptr_State_Activity) is
   begin
      --delete this->myActivity;
      print(debug,"Leaf_State--Set_Activity--This.My_Activity := " & State_Act.Get_Name);
      This.My_Activity := null;
      This.My_Activity := State_Act;
   end Set_Activity;

   --------------------------Minfr_State--------------------------

   procedure On_Entry (This : in out Leaf_State) is
   begin
      print(debug,"Leaf_State--On_Entry--" & This.My_Activity.Get_Name& ".Execute_On_Entry");
      This.Active := true;
      This.My_Activity.Execute_On_Entry;
      exception
      when others =>
         print(true,"Leaf_State--On_Entry--" & this.Get_Name &"--exception");
         delay 10.00;
   end On_Entry;

   procedure On_Exit (This : in out Leaf_State) is
   begin
      print(debug,"Leaf_State--On_Exit--" & This.My_Activity.Get_Name);
      This.My_Activity.Execute_On_Exit;
      This.Active := false;
      exception
      when others =>
         print(true,"Leaf_State--On_Exit--" & this.Get_Name &"--exception");
         delay 10.00;
   end On_Exit;

   function Resolve_Next_State (This : Leaf_State) return State_Id is
      Next_State : State_Id := 0;
      debug : boolean := false;
      --int nextState=-1;
   begin
      print(debug,"Leaf_State-- Resolve_Next_State--transitions.Length:" & Index_Vector'Image(Index_Vector(this.transitions.Length)));
      Pulse_key(debug);
      if this.transitions.Length > 0 then
         For_Loop :
         for I in Index_Vector range 0 .. Index_Vector(this.transitions.Length-1) loop
            --result := this.Evaluate_Conditions(this.conditions.Element(I));
            print(debug,"Leaf_State--Resolve_Next_State--" & This.transitions.Element(I).Get_Name &".Evaluate_Transition");
            Pulse_key(debug);
            if This.transitions.Element(I).Evaluate_Transition then
               print(debug,"Leaf_State--Resolve_Next_State--" & This.transitions.Element(I).Get_Name &".Evaluate_Transition = True");
               Pulse_key(debug);
               Next_State := This.transitions.Element(I).Get_State;
               print(debug,"Leaf_State--Resolve_Next_State--Next_State =" & State_Id'Image(Next_State));
               Pulse_key(debug);
               exit  For_Loop;

            end if;
            --   print(debug,"Leaf_State--Resolve_Next_State--" & This.transitions.Element(I).Get_Name &".Evaluate_Transition = False");
         end loop For_Loop;
      else
         Next_State := This.St_Id;
      end if;

      print(debug,"Leaf_State--Resolve_Next_State--Return--"& State_Id'Image(Next_State));
      Pulse_key(debug);
      return Next_State;
      exception
      when others =>
         print(true,"Leaf_State--Resolve_Next_State--" & this.Get_Name &"--exception");
         delay 10.00;
         return 1;
   end Resolve_Next_State;

end minfr.Minfr_State.Leaf_State;
