with Minfr.MinFr_Component_Data.MinFr_Data,
     Minfr.Transition,
     Minfr.State_Activity,
     Ada.Containers.Vectors;


use Minfr.MinFr_Component_Data.MinFr_Data,
    Minfr.Transition,
    Minfr.State_Activity,
    Ada.Containers;



package minfr.Minfr_State.Leaf_State is

   type Leaf_State (<>) is new Minfr_State with private;
   type Ptr_Leaf_State is access Leaf_State;
   type Index_Vector is new Natural;

   ---------Constructores----------
   not overriding
   function Constr_Leaf_State (stID : State_Id; name : string) return Ptr_Leaf_State;
   ----------------------------------------------------------------
   not overriding
   procedure Add_Transition(This : in out Leaf_State; trans : Ptr_Transition);
   not overriding
   procedure Set_Activity(This : in out Leaf_State; State_Act : Ptr_State_Activity);
   --------------------------Minfr_State--------------------------
   overriding
   procedure On_Entry (This : in out Leaf_State);
   overriding
   procedure On_Exit (This : in out Leaf_State);
   overriding
   function Resolve_Next_State (This : Leaf_State) return State_Id;

private

   Debug : boolean := false;

   package Vector_ptr_Transition is new Vectors (Index_Vector,Ptr_Transition);
   use Vector_ptr_Transition;

   type Leaf_State is new Minfr_State with record
      transitions : vector;
   end record;


end minfr.Minfr_State.Leaf_State;
