with minfr.Debug;
use minfr.Debug;

package body minfr.Minfr_State is

   -------------------
   -- Constr_Minfr_State --
   -------------------
   procedure Constr_Minfr_State (This :in out Minfr_State_Ptr; Id : State_Id) is
   begin
      This.St_Id := Id;
      This.My_Activity := Ptr_state_Activity(Constr_Null_Activity);
      this.Name := To_Unbounded_String ("NoName_st");
      this.Active := false;
   end Constr_Minfr_State;


   ------------------
   -- Execute_Tick --
   ------------------

   procedure Execute_Tick (This : in out Minfr_State) is
   begin
      print(debug,"Minfr_State--Execute_Tick--" & This.My_Activity.Get_Name & ".Execute_Tick");
      Pulse_key(debug);
      This.My_Activity.Execute_Tick;
   end Execute_Tick;

   ----------------
   --Get_Activity --
   ----------------


  function Get_Activity (This : Minfr_State) return Ptr_State_Activity is
   begin
      return This.My_Activity;
   end Get_Activity;

   --------------------
   -- Get_Identifier --
   --------------------

   function Get_Id (This :Minfr_State) return State_Id is
   begin
      return This.St_Id;
   end Get_Id;

   ---------------
   -- Is_Active --
   ---------------

   function Is_Active (This : Minfr_State) return Boolean is
   begin
      return This.Active;
   end Is_Active;

   --------------
   -- Get_Name --
   --------------

   function Get_Name (This : Minfr_State) return String is
   begin
      return To_String(This.Name);
   end Get_Name;

   -------------
   -- Is_Done --
   -------------

   function Is_Done (This : Minfr_State) return Boolean is
   begin
      return This.My_Activity.Is_Done;
   end Is_Done;



end minfr.Minfr_State;
