with Ada.Strings.Unbounded,
     Minfr.State_Activity,
     Minfr.State_Activity.Leaf_Activity.Null_Activity;

use Ada.Strings.Unbounded,
    Minfr.State_Activity,
    Minfr.State_Activity.Leaf_Activity.Null_Activity;


package minfr.Minfr_State is


   type State_Id is new Natural;

   type Minfr_State is abstract tagged private;


--     type Minfr_State is abstract tagged record
--        Name                 : Unbounded_String;
--        My_Activity          : Ptr_State_Activity;
--        St_Id                : State_Id;
--        Active               : Boolean;
--        Last_Id		   : State_Id;
--        pragma Atomic (St_Id);
--        pragma Atomic (Active);
--     end record;

   type Minfr_State_Ptr is access all Minfr_State'Class;

   not overriding
   procedure Constr_Minfr_State (This :in out Minfr_State_Ptr; Id : State_Id);

   not overriding
   procedure On_Entry (This : in out Minfr_State) is abstract;
   not overriding
   procedure On_Exit (This : in out Minfr_State) is abstract;

   not overriding
   procedure Execute_Tick (This : in out Minfr_State);
   not overriding
   function Resolve_Next_State (This : Minfr_State) return State_Id is abstract;
   not overriding
   function Get_Activity (This : Minfr_State) return Ptr_State_Activity;
   not overriding
   function Get_Id (This : Minfr_State) return State_Id;
   not overriding
   function Is_Active (This : Minfr_State) return Boolean;
   not overriding
   function Get_Name (This : Minfr_State) return String;
   not overriding
   function Is_Done (This :Minfr_State) return Boolean;


private

   Debug : boolean := False;

   type Minfr_State is abstract tagged record
      Name                 : Unbounded_String;
      My_Activity          : Ptr_State_Activity;
      St_Id                : State_Id;
      Active               : Boolean;
      Last_Id		   : State_Id;
      pragma Atomic (St_Id);
      pragma Atomic (Active);
   end record;


end  minfr.Minfr_State;
